/* service.c generated by valac 0.15.2, the Vala compiler
 * generated from service.vala, do not modify */

/*
 * Copyright(C) 2010 Neil Jagdish Patel
 * Copyright(C) 2010 Canonical Ltd.
 *
 * This library is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License
 * version 3.0 as published by the Free Software Foundation.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License version 3.0 for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library. If not, see
 * <http://www.gnu.org/licenses/>.
 *
 * Authored by Neil Jagdish Patel <neil.patel@canonical.com>
 * Authored by Ken VaDine <ken.vandine@canonical.com>
 */

#include <glib.h>
#include <glib-object.h>
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>
#include "gwibber.h"
#include <json-glib/json-glib.h>


#define TYPE_SERVICE_INTERFACE (service_interface_get_type ())
#define SERVICE_INTERFACE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SERVICE_INTERFACE, ServiceInterface))
#define IS_SERVICE_INTERFACE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SERVICE_INTERFACE))
#define SERVICE_INTERFACE_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), TYPE_SERVICE_INTERFACE, ServiceInterfaceIface))

typedef struct _ServiceInterface ServiceInterface;
typedef struct _ServiceInterfaceIface ServiceInterfaceIface;

#define TYPE_SERVICE_INTERFACE_PROXY (service_interface_proxy_get_type ())
typedef GDBusProxy ServiceInterfaceProxy;
typedef GDBusProxyClass ServiceInterfaceProxyClass;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_hash_table_unref0(var) ((var == NULL) ? NULL : (var = (g_hash_table_unref (var), NULL)))
#define __vala_JsonObject_free0(var) ((var == NULL) ? NULL : (var = (_vala_JsonObject_free (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define __vala_JsonNode_free0(var) ((var == NULL) ? NULL : (var = (_vala_JsonNode_free (var), NULL)))
#define __vala_JsonArray_free0(var) ((var == NULL) ? NULL : (var = (_vala_JsonArray_free (var), NULL)))
#define __g_list_free__g_free0_0(var) ((var == NULL) ? NULL : (var = (_g_list_free__g_free0_ (var), NULL)))
#define _g_list_free0(var) ((var == NULL) ? NULL : (var = (g_list_free (var), NULL)))
#define __vala_GValue_free0(var) ((var == NULL) ? NULL : (var = (_vala_GValue_free (var), NULL)))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))

struct _ServiceInterfaceIface {
	GTypeInterface parent_iface;
	void (*Start) (ServiceInterface* self, GError** error);
	void (*Quit) (ServiceInterface* self, GError** error);
	void (*Refresh) (ServiceInterface* self, GError** error);
	void (*SendMessage) (ServiceInterface* self, const gchar* msg, GError** error);
	void (*Send) (ServiceInterface* self, const gchar* msg, GError** error);
	void (*Like) (ServiceInterface* self, const gchar* mid, const gchar* account, GError** error);
	void (*UnLike) (ServiceInterface* self, const gchar* mid, const gchar* account, GError** error);
	void (*Retweet) (ServiceInterface* self, const gchar* mid, const gchar* account, GError** error);
	void (*PerformOp) (ServiceInterface* self, const gchar* op, GError** error);
	void (*UpdateIndicators) (ServiceInterface* self, const gchar* stream, GError** error);
	gchar* (*GetAvatarPath) (ServiceInterface* self, const gchar* url, GError** error);
	gchar* (*GetFeatures) (ServiceInterface* self, GError** error);
	gchar* (*GetServices) (ServiceInterface* self, GError** error);
	gchar* (*GetVersion) (ServiceInterface* self, GError** error);
};

struct _GwibberServicePrivate {
	ServiceInterface* service;
	GHashTable* services_table;
	GHashTable* service_table;
	GHashTable* features_table;
	GHashTable* feature_table;
	GwibberUtils* utils;
	GwibberMessages* messages;
};


static gpointer gwibber_service_parent_class = NULL;

GType service_interface_proxy_get_type (void) G_GNUC_CONST;
guint service_interface_register_object (void* object, GDBusConnection* connection, const gchar* path, GError** error);
GType service_interface_get_type (void) G_GNUC_CONST;
void service_interface_Start (ServiceInterface* self, GError** error);
void service_interface_Quit (ServiceInterface* self, GError** error);
void service_interface_Refresh (ServiceInterface* self, GError** error);
void service_interface_SendMessage (ServiceInterface* self, const gchar* msg, GError** error);
void service_interface_Send (ServiceInterface* self, const gchar* msg, GError** error);
void service_interface_Like (ServiceInterface* self, const gchar* mid, const gchar* account, GError** error);
void service_interface_UnLike (ServiceInterface* self, const gchar* mid, const gchar* account, GError** error);
void service_interface_Retweet (ServiceInterface* self, const gchar* mid, const gchar* account, GError** error);
void service_interface_PerformOp (ServiceInterface* self, const gchar* op, GError** error);
void service_interface_UpdateIndicators (ServiceInterface* self, const gchar* stream, GError** error);
gchar* service_interface_GetAvatarPath (ServiceInterface* self, const gchar* url, GError** error);
gchar* service_interface_GetFeatures (ServiceInterface* self, GError** error);
gchar* service_interface_GetServices (ServiceInterface* self, GError** error);
gchar* service_interface_GetVersion (ServiceInterface* self, GError** error);
static void service_interface_proxy_g_signal (GDBusProxy* proxy, const gchar* sender_name, const gchar* signal_name, GVariant* parameters);
static void _dbus_handle_service_interface_loading_started (ServiceInterface* self, GVariant* parameters);
static void _dbus_handle_service_interface_loading_complete (ServiceInterface* self, GVariant* parameters);
static void _dbus_handle_service_interface_error (ServiceInterface* self, GVariant* parameters);
static void service_interface_proxy_Start (ServiceInterface* self, GError** error);
static void service_interface_proxy_Quit (ServiceInterface* self, GError** error);
static void service_interface_proxy_Refresh (ServiceInterface* self, GError** error);
static void service_interface_proxy_SendMessage (ServiceInterface* self, const gchar* msg, GError** error);
static void service_interface_proxy_Send (ServiceInterface* self, const gchar* msg, GError** error);
static void service_interface_proxy_Like (ServiceInterface* self, const gchar* mid, const gchar* account, GError** error);
static void service_interface_proxy_UnLike (ServiceInterface* self, const gchar* mid, const gchar* account, GError** error);
static void service_interface_proxy_Retweet (ServiceInterface* self, const gchar* mid, const gchar* account, GError** error);
static void service_interface_proxy_PerformOp (ServiceInterface* self, const gchar* op, GError** error);
static void service_interface_proxy_UpdateIndicators (ServiceInterface* self, const gchar* stream, GError** error);
static gchar* service_interface_proxy_GetAvatarPath (ServiceInterface* self, const gchar* url, GError** error);
static gchar* service_interface_proxy_GetFeatures (ServiceInterface* self, GError** error);
static gchar* service_interface_proxy_GetServices (ServiceInterface* self, GError** error);
static gchar* service_interface_proxy_GetVersion (ServiceInterface* self, GError** error);
static void service_interface_proxy_service_interface_interface_init (ServiceInterfaceIface* iface);
static void _dbus_service_interface_Start (ServiceInterface* self, GVariant* parameters, GDBusMethodInvocation* invocation);
static void _dbus_service_interface_Quit (ServiceInterface* self, GVariant* parameters, GDBusMethodInvocation* invocation);
static void _dbus_service_interface_Refresh (ServiceInterface* self, GVariant* parameters, GDBusMethodInvocation* invocation);
static void _dbus_service_interface_SendMessage (ServiceInterface* self, GVariant* parameters, GDBusMethodInvocation* invocation);
static void _dbus_service_interface_Send (ServiceInterface* self, GVariant* parameters, GDBusMethodInvocation* invocation);
static void _dbus_service_interface_Like (ServiceInterface* self, GVariant* parameters, GDBusMethodInvocation* invocation);
static void _dbus_service_interface_UnLike (ServiceInterface* self, GVariant* parameters, GDBusMethodInvocation* invocation);
static void _dbus_service_interface_Retweet (ServiceInterface* self, GVariant* parameters, GDBusMethodInvocation* invocation);
static void _dbus_service_interface_PerformOp (ServiceInterface* self, GVariant* parameters, GDBusMethodInvocation* invocation);
static void _dbus_service_interface_UpdateIndicators (ServiceInterface* self, GVariant* parameters, GDBusMethodInvocation* invocation);
static void _dbus_service_interface_GetAvatarPath (ServiceInterface* self, GVariant* parameters, GDBusMethodInvocation* invocation);
static void _dbus_service_interface_GetFeatures (ServiceInterface* self, GVariant* parameters, GDBusMethodInvocation* invocation);
static void _dbus_service_interface_GetServices (ServiceInterface* self, GVariant* parameters, GDBusMethodInvocation* invocation);
static void _dbus_service_interface_GetVersion (ServiceInterface* self, GVariant* parameters, GDBusMethodInvocation* invocation);
static void service_interface_dbus_interface_method_call (GDBusConnection* connection, const gchar* sender, const gchar* object_path, const gchar* interface_name, const gchar* method_name, GVariant* parameters, GDBusMethodInvocation* invocation, gpointer user_data);
static GVariant* service_interface_dbus_interface_get_property (GDBusConnection* connection, const gchar* sender, const gchar* object_path, const gchar* interface_name, const gchar* property_name, GError** error, gpointer user_data);
static gboolean service_interface_dbus_interface_set_property (GDBusConnection* connection, const gchar* sender, const gchar* object_path, const gchar* interface_name, const gchar* property_name, GVariant* value, GError** error, gpointer user_data);
static void _dbus_service_interface_loading_started (GObject* _sender, gpointer* _data);
static void _dbus_service_interface_loading_complete (GObject* _sender, gpointer* _data);
static void _dbus_service_interface_error (GObject* _sender, const gchar* error_str, gpointer* _data);
static void _service_interface_unregister_object (gpointer user_data);
#define GWIBBER_SERVICE_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), GWIBBER_TYPE_SERVICE, GwibberServicePrivate))
enum  {
	GWIBBER_SERVICE_DUMMY_PROPERTY
};
#define GWIBBER_SERVICE_service_name "com.Gwibber.Service"
#define GWIBBER_SERVICE_service_path "/com/gwibber/Service"
static JsonObject* _vala_JsonObject_copy (JsonObject* self);
static void _vala_JsonObject_free (JsonObject* self);
static void _vala_JsonNode_free (JsonNode* self);
static JsonArray* _vala_JsonArray_copy (JsonArray* self);
static void _vala_JsonArray_free (JsonArray* self);
static void _g_hash_table_remove_all_gdestroy_notify (void* data);
static void _g_free0_ (gpointer var);
static void _g_list_free__g_free0_ (GList* self);
static void _vala_GValue_free (GValue* self);
static GValue* _g_value_dup (GValue* self);
static void g_cclosure_user_marshal_VOID__STRING_STRING_STRING (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data);
static GObject * gwibber_service_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties);
void gwibber_utils_setup (GwibberUtils* self, const gchar* name, GError** error);
static void _gwibber_service_service_available_gwibber_utils_available (GwibberUtils* _sender, gboolean up, gpointer self);
static void _gwibber_service_on_loading_started_service_interface_loading_started (ServiceInterface* _sender, gpointer self);
static void _gwibber_service_on_loading_complete_service_interface_loading_complete (ServiceInterface* _sender, gpointer self);
static void _gwibber_service____lambda6_ (GwibberService* self, const gchar* source);
static void __gwibber_service____lambda6__service_interface_error (ServiceInterface* _sender, const gchar* error_str, gpointer self);
static void gwibber_service_finalize (GObject* obj);

static const GDBusArgInfo * const _service_interface_dbus_arg_info_Start_in[] = {NULL};
static const GDBusArgInfo * const _service_interface_dbus_arg_info_Start_out[] = {NULL};
static const GDBusMethodInfo _service_interface_dbus_method_info_Start = {-1, "Start", (GDBusArgInfo **) (&_service_interface_dbus_arg_info_Start_in), (GDBusArgInfo **) (&_service_interface_dbus_arg_info_Start_out)};
static const GDBusArgInfo * const _service_interface_dbus_arg_info_Quit_in[] = {NULL};
static const GDBusArgInfo * const _service_interface_dbus_arg_info_Quit_out[] = {NULL};
static const GDBusMethodInfo _service_interface_dbus_method_info_Quit = {-1, "Quit", (GDBusArgInfo **) (&_service_interface_dbus_arg_info_Quit_in), (GDBusArgInfo **) (&_service_interface_dbus_arg_info_Quit_out)};
static const GDBusArgInfo * const _service_interface_dbus_arg_info_Refresh_in[] = {NULL};
static const GDBusArgInfo * const _service_interface_dbus_arg_info_Refresh_out[] = {NULL};
static const GDBusMethodInfo _service_interface_dbus_method_info_Refresh = {-1, "Refresh", (GDBusArgInfo **) (&_service_interface_dbus_arg_info_Refresh_in), (GDBusArgInfo **) (&_service_interface_dbus_arg_info_Refresh_out)};
static const GDBusArgInfo _service_interface_dbus_arg_info_SendMessage_msg = {-1, "msg", "s"};
static const GDBusArgInfo * const _service_interface_dbus_arg_info_SendMessage_in[] = {&_service_interface_dbus_arg_info_SendMessage_msg, NULL};
static const GDBusArgInfo * const _service_interface_dbus_arg_info_SendMessage_out[] = {NULL};
static const GDBusMethodInfo _service_interface_dbus_method_info_SendMessage = {-1, "SendMessage", (GDBusArgInfo **) (&_service_interface_dbus_arg_info_SendMessage_in), (GDBusArgInfo **) (&_service_interface_dbus_arg_info_SendMessage_out)};
static const GDBusArgInfo _service_interface_dbus_arg_info_Send_msg = {-1, "msg", "s"};
static const GDBusArgInfo * const _service_interface_dbus_arg_info_Send_in[] = {&_service_interface_dbus_arg_info_Send_msg, NULL};
static const GDBusArgInfo * const _service_interface_dbus_arg_info_Send_out[] = {NULL};
static const GDBusMethodInfo _service_interface_dbus_method_info_Send = {-1, "Send", (GDBusArgInfo **) (&_service_interface_dbus_arg_info_Send_in), (GDBusArgInfo **) (&_service_interface_dbus_arg_info_Send_out)};
static const GDBusArgInfo _service_interface_dbus_arg_info_Like_mid = {-1, "mid", "s"};
static const GDBusArgInfo _service_interface_dbus_arg_info_Like_account = {-1, "account", "s"};
static const GDBusArgInfo * const _service_interface_dbus_arg_info_Like_in[] = {&_service_interface_dbus_arg_info_Like_mid, &_service_interface_dbus_arg_info_Like_account, NULL};
static const GDBusArgInfo * const _service_interface_dbus_arg_info_Like_out[] = {NULL};
static const GDBusMethodInfo _service_interface_dbus_method_info_Like = {-1, "Like", (GDBusArgInfo **) (&_service_interface_dbus_arg_info_Like_in), (GDBusArgInfo **) (&_service_interface_dbus_arg_info_Like_out)};
static const GDBusArgInfo _service_interface_dbus_arg_info_UnLike_mid = {-1, "mid", "s"};
static const GDBusArgInfo _service_interface_dbus_arg_info_UnLike_account = {-1, "account", "s"};
static const GDBusArgInfo * const _service_interface_dbus_arg_info_UnLike_in[] = {&_service_interface_dbus_arg_info_UnLike_mid, &_service_interface_dbus_arg_info_UnLike_account, NULL};
static const GDBusArgInfo * const _service_interface_dbus_arg_info_UnLike_out[] = {NULL};
static const GDBusMethodInfo _service_interface_dbus_method_info_UnLike = {-1, "UnLike", (GDBusArgInfo **) (&_service_interface_dbus_arg_info_UnLike_in), (GDBusArgInfo **) (&_service_interface_dbus_arg_info_UnLike_out)};
static const GDBusArgInfo _service_interface_dbus_arg_info_Retweet_mid = {-1, "mid", "s"};
static const GDBusArgInfo _service_interface_dbus_arg_info_Retweet_account = {-1, "account", "s"};
static const GDBusArgInfo * const _service_interface_dbus_arg_info_Retweet_in[] = {&_service_interface_dbus_arg_info_Retweet_mid, &_service_interface_dbus_arg_info_Retweet_account, NULL};
static const GDBusArgInfo * const _service_interface_dbus_arg_info_Retweet_out[] = {NULL};
static const GDBusMethodInfo _service_interface_dbus_method_info_Retweet = {-1, "Retweet", (GDBusArgInfo **) (&_service_interface_dbus_arg_info_Retweet_in), (GDBusArgInfo **) (&_service_interface_dbus_arg_info_Retweet_out)};
static const GDBusArgInfo _service_interface_dbus_arg_info_PerformOp_op = {-1, "op", "s"};
static const GDBusArgInfo * const _service_interface_dbus_arg_info_PerformOp_in[] = {&_service_interface_dbus_arg_info_PerformOp_op, NULL};
static const GDBusArgInfo * const _service_interface_dbus_arg_info_PerformOp_out[] = {NULL};
static const GDBusMethodInfo _service_interface_dbus_method_info_PerformOp = {-1, "PerformOp", (GDBusArgInfo **) (&_service_interface_dbus_arg_info_PerformOp_in), (GDBusArgInfo **) (&_service_interface_dbus_arg_info_PerformOp_out)};
static const GDBusArgInfo _service_interface_dbus_arg_info_UpdateIndicators_stream = {-1, "stream", "s"};
static const GDBusArgInfo * const _service_interface_dbus_arg_info_UpdateIndicators_in[] = {&_service_interface_dbus_arg_info_UpdateIndicators_stream, NULL};
static const GDBusArgInfo * const _service_interface_dbus_arg_info_UpdateIndicators_out[] = {NULL};
static const GDBusMethodInfo _service_interface_dbus_method_info_UpdateIndicators = {-1, "UpdateIndicators", (GDBusArgInfo **) (&_service_interface_dbus_arg_info_UpdateIndicators_in), (GDBusArgInfo **) (&_service_interface_dbus_arg_info_UpdateIndicators_out)};
static const GDBusArgInfo _service_interface_dbus_arg_info_GetAvatarPath_url = {-1, "url", "s"};
static const GDBusArgInfo _service_interface_dbus_arg_info_GetAvatarPath_result = {-1, "result", "s"};
static const GDBusArgInfo * const _service_interface_dbus_arg_info_GetAvatarPath_in[] = {&_service_interface_dbus_arg_info_GetAvatarPath_url, NULL};
static const GDBusArgInfo * const _service_interface_dbus_arg_info_GetAvatarPath_out[] = {&_service_interface_dbus_arg_info_GetAvatarPath_result, NULL};
static const GDBusMethodInfo _service_interface_dbus_method_info_GetAvatarPath = {-1, "GetAvatarPath", (GDBusArgInfo **) (&_service_interface_dbus_arg_info_GetAvatarPath_in), (GDBusArgInfo **) (&_service_interface_dbus_arg_info_GetAvatarPath_out)};
static const GDBusArgInfo _service_interface_dbus_arg_info_GetFeatures_result = {-1, "result", "s"};
static const GDBusArgInfo * const _service_interface_dbus_arg_info_GetFeatures_in[] = {NULL};
static const GDBusArgInfo * const _service_interface_dbus_arg_info_GetFeatures_out[] = {&_service_interface_dbus_arg_info_GetFeatures_result, NULL};
static const GDBusMethodInfo _service_interface_dbus_method_info_GetFeatures = {-1, "GetFeatures", (GDBusArgInfo **) (&_service_interface_dbus_arg_info_GetFeatures_in), (GDBusArgInfo **) (&_service_interface_dbus_arg_info_GetFeatures_out)};
static const GDBusArgInfo _service_interface_dbus_arg_info_GetServices_result = {-1, "result", "s"};
static const GDBusArgInfo * const _service_interface_dbus_arg_info_GetServices_in[] = {NULL};
static const GDBusArgInfo * const _service_interface_dbus_arg_info_GetServices_out[] = {&_service_interface_dbus_arg_info_GetServices_result, NULL};
static const GDBusMethodInfo _service_interface_dbus_method_info_GetServices = {-1, "GetServices", (GDBusArgInfo **) (&_service_interface_dbus_arg_info_GetServices_in), (GDBusArgInfo **) (&_service_interface_dbus_arg_info_GetServices_out)};
static const GDBusArgInfo _service_interface_dbus_arg_info_GetVersion_result = {-1, "result", "s"};
static const GDBusArgInfo * const _service_interface_dbus_arg_info_GetVersion_in[] = {NULL};
static const GDBusArgInfo * const _service_interface_dbus_arg_info_GetVersion_out[] = {&_service_interface_dbus_arg_info_GetVersion_result, NULL};
static const GDBusMethodInfo _service_interface_dbus_method_info_GetVersion = {-1, "GetVersion", (GDBusArgInfo **) (&_service_interface_dbus_arg_info_GetVersion_in), (GDBusArgInfo **) (&_service_interface_dbus_arg_info_GetVersion_out)};
static const GDBusMethodInfo * const _service_interface_dbus_method_info[] = {&_service_interface_dbus_method_info_Start, &_service_interface_dbus_method_info_Quit, &_service_interface_dbus_method_info_Refresh, &_service_interface_dbus_method_info_SendMessage, &_service_interface_dbus_method_info_Send, &_service_interface_dbus_method_info_Like, &_service_interface_dbus_method_info_UnLike, &_service_interface_dbus_method_info_Retweet, &_service_interface_dbus_method_info_PerformOp, &_service_interface_dbus_method_info_UpdateIndicators, &_service_interface_dbus_method_info_GetAvatarPath, &_service_interface_dbus_method_info_GetFeatures, &_service_interface_dbus_method_info_GetServices, &_service_interface_dbus_method_info_GetVersion, NULL};
static const GDBusArgInfo * const _service_interface_dbus_arg_info_loading_started[] = {NULL};
static const GDBusSignalInfo _service_interface_dbus_signal_info_loading_started = {-1, "LoadingStarted", (GDBusArgInfo **) (&_service_interface_dbus_arg_info_loading_started)};
static const GDBusArgInfo * const _service_interface_dbus_arg_info_loading_complete[] = {NULL};
static const GDBusSignalInfo _service_interface_dbus_signal_info_loading_complete = {-1, "LoadingComplete", (GDBusArgInfo **) (&_service_interface_dbus_arg_info_loading_complete)};
static const GDBusArgInfo _service_interface_dbus_arg_info_error_error_str = {-1, "error_str", "s"};
static const GDBusArgInfo * const _service_interface_dbus_arg_info_error[] = {&_service_interface_dbus_arg_info_error_error_str, NULL};
static const GDBusSignalInfo _service_interface_dbus_signal_info_error = {-1, "Error", (GDBusArgInfo **) (&_service_interface_dbus_arg_info_error)};
static const GDBusSignalInfo * const _service_interface_dbus_signal_info[] = {&_service_interface_dbus_signal_info_loading_started, &_service_interface_dbus_signal_info_loading_complete, &_service_interface_dbus_signal_info_error, NULL};
static const GDBusPropertyInfo * const _service_interface_dbus_property_info[] = {NULL};
static const GDBusInterfaceInfo _service_interface_dbus_interface_info = {-1, "com.Gwibber.Service", (GDBusMethodInfo **) (&_service_interface_dbus_method_info), (GDBusSignalInfo **) (&_service_interface_dbus_signal_info), (GDBusPropertyInfo **) (&_service_interface_dbus_property_info)};
static const GDBusInterfaceVTable _service_interface_dbus_interface_vtable = {service_interface_dbus_interface_method_call, service_interface_dbus_interface_get_property, service_interface_dbus_interface_set_property};

void service_interface_Start (ServiceInterface* self, GError** error) {
#line 24 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
	g_return_if_fail (self != NULL);
#line 24 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
	SERVICE_INTERFACE_GET_INTERFACE (self)->Start (self, error);
#line 247 "service.c"
}


void service_interface_Quit (ServiceInterface* self, GError** error) {
#line 25 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
	g_return_if_fail (self != NULL);
#line 25 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
	SERVICE_INTERFACE_GET_INTERFACE (self)->Quit (self, error);
#line 256 "service.c"
}


void service_interface_Refresh (ServiceInterface* self, GError** error) {
#line 26 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
	g_return_if_fail (self != NULL);
#line 26 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
	SERVICE_INTERFACE_GET_INTERFACE (self)->Refresh (self, error);
#line 265 "service.c"
}


void service_interface_SendMessage (ServiceInterface* self, const gchar* msg, GError** error) {
#line 27 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
	g_return_if_fail (self != NULL);
#line 27 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
	SERVICE_INTERFACE_GET_INTERFACE (self)->SendMessage (self, msg, error);
#line 274 "service.c"
}


void service_interface_Send (ServiceInterface* self, const gchar* msg, GError** error) {
#line 28 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
	g_return_if_fail (self != NULL);
#line 28 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
	SERVICE_INTERFACE_GET_INTERFACE (self)->Send (self, msg, error);
#line 283 "service.c"
}


void service_interface_Like (ServiceInterface* self, const gchar* mid, const gchar* account, GError** error) {
#line 29 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
	g_return_if_fail (self != NULL);
#line 29 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
	SERVICE_INTERFACE_GET_INTERFACE (self)->Like (self, mid, account, error);
#line 292 "service.c"
}


void service_interface_UnLike (ServiceInterface* self, const gchar* mid, const gchar* account, GError** error) {
#line 30 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
	g_return_if_fail (self != NULL);
#line 30 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
	SERVICE_INTERFACE_GET_INTERFACE (self)->UnLike (self, mid, account, error);
#line 301 "service.c"
}


void service_interface_Retweet (ServiceInterface* self, const gchar* mid, const gchar* account, GError** error) {
#line 31 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
	g_return_if_fail (self != NULL);
#line 31 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
	SERVICE_INTERFACE_GET_INTERFACE (self)->Retweet (self, mid, account, error);
#line 310 "service.c"
}


void service_interface_PerformOp (ServiceInterface* self, const gchar* op, GError** error) {
#line 32 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
	g_return_if_fail (self != NULL);
#line 32 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
	SERVICE_INTERFACE_GET_INTERFACE (self)->PerformOp (self, op, error);
#line 319 "service.c"
}


void service_interface_UpdateIndicators (ServiceInterface* self, const gchar* stream, GError** error) {
#line 33 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
	g_return_if_fail (self != NULL);
#line 33 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
	SERVICE_INTERFACE_GET_INTERFACE (self)->UpdateIndicators (self, stream, error);
#line 328 "service.c"
}


gchar* service_interface_GetAvatarPath (ServiceInterface* self, const gchar* url, GError** error) {
#line 34 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 34 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
	return SERVICE_INTERFACE_GET_INTERFACE (self)->GetAvatarPath (self, url, error);
#line 337 "service.c"
}


gchar* service_interface_GetFeatures (ServiceInterface* self, GError** error) {
#line 35 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 35 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
	return SERVICE_INTERFACE_GET_INTERFACE (self)->GetFeatures (self, error);
#line 346 "service.c"
}


gchar* service_interface_GetServices (ServiceInterface* self, GError** error) {
#line 36 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 36 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
	return SERVICE_INTERFACE_GET_INTERFACE (self)->GetServices (self, error);
#line 355 "service.c"
}


gchar* service_interface_GetVersion (ServiceInterface* self, GError** error) {
#line 37 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 37 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
	return SERVICE_INTERFACE_GET_INTERFACE (self)->GetVersion (self, error);
#line 364 "service.c"
}


static void service_interface_base_init (ServiceInterfaceIface * iface) {
#line 23 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
	static gboolean initialized = FALSE;
#line 23 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
	if (!initialized) {
#line 23 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		initialized = TRUE;
#line 23 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		g_signal_new ("loading_started", TYPE_SERVICE_INTERFACE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 23 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		g_signal_new ("loading_complete", TYPE_SERVICE_INTERFACE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 23 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		g_signal_new ("error", TYPE_SERVICE_INTERFACE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__STRING, G_TYPE_NONE, 1, G_TYPE_STRING);
#line 381 "service.c"
	}
}


GType service_interface_get_type (void) {
	static volatile gsize service_interface_type_id__volatile = 0;
	if (g_once_init_enter (&service_interface_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (ServiceInterfaceIface), (GBaseInitFunc) service_interface_base_init, (GBaseFinalizeFunc) NULL, (GClassInitFunc) NULL, (GClassFinalizeFunc) NULL, NULL, 0, 0, (GInstanceInitFunc) NULL, NULL };
		GType service_interface_type_id;
		service_interface_type_id = g_type_register_static (G_TYPE_INTERFACE, "ServiceInterface", &g_define_type_info, 0);
		g_type_interface_add_prerequisite (service_interface_type_id, G_TYPE_OBJECT);
		g_type_set_qdata (service_interface_type_id, g_quark_from_static_string ("vala-dbus-proxy-type"), (void*) service_interface_proxy_get_type);
		g_type_set_qdata (service_interface_type_id, g_quark_from_static_string ("vala-dbus-interface-name"), "com.Gwibber.Service");
		g_type_set_qdata (service_interface_type_id, g_quark_from_static_string ("vala-dbus-register-object"), (void*) service_interface_register_object);
		g_once_init_leave (&service_interface_type_id__volatile, service_interface_type_id);
	}
	return service_interface_type_id__volatile;
}


G_DEFINE_TYPE_EXTENDED (ServiceInterfaceProxy, service_interface_proxy, G_TYPE_DBUS_PROXY, 0, G_IMPLEMENT_INTERFACE (TYPE_SERVICE_INTERFACE, service_interface_proxy_service_interface_interface_init) )
static void service_interface_proxy_class_init (ServiceInterfaceProxyClass* klass) {
	G_DBUS_PROXY_CLASS (klass)->g_signal = service_interface_proxy_g_signal;
}


static void _dbus_handle_service_interface_loading_started (ServiceInterface* self, GVariant* parameters) {
	GVariantIter _arguments_iter;
	g_variant_iter_init (&_arguments_iter, parameters);
	g_signal_emit_by_name (self, "loading-started");
}


static void _dbus_handle_service_interface_loading_complete (ServiceInterface* self, GVariant* parameters) {
	GVariantIter _arguments_iter;
	g_variant_iter_init (&_arguments_iter, parameters);
	g_signal_emit_by_name (self, "loading-complete");
}


static void _dbus_handle_service_interface_error (ServiceInterface* self, GVariant* parameters) {
	GVariantIter _arguments_iter;
	gchar* error_str = NULL;
	GVariant* _tmp8_;
	g_variant_iter_init (&_arguments_iter, parameters);
	_tmp8_ = g_variant_iter_next_value (&_arguments_iter);
	error_str = g_variant_dup_string (_tmp8_, NULL);
	g_variant_unref (_tmp8_);
	g_signal_emit_by_name (self, "error", error_str);
	_g_free0 (error_str);
}


static void service_interface_proxy_g_signal (GDBusProxy* proxy, const gchar* sender_name, const gchar* signal_name, GVariant* parameters) {
	if (strcmp (signal_name, "LoadingStarted") == 0) {
		_dbus_handle_service_interface_loading_started ((ServiceInterface*) proxy, parameters);
	} else if (strcmp (signal_name, "LoadingComplete") == 0) {
		_dbus_handle_service_interface_loading_complete ((ServiceInterface*) proxy, parameters);
	} else if (strcmp (signal_name, "Error") == 0) {
		_dbus_handle_service_interface_error ((ServiceInterface*) proxy, parameters);
	}
}


static void service_interface_proxy_init (ServiceInterfaceProxy* self) {
}


static void service_interface_proxy_Start (ServiceInterface* self, GError** error) {
	GDBusMessage *_message;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	GDBusMessage *_reply_message;
	G_IO_ERROR;
	_message = g_dbus_message_new_method_call (g_dbus_proxy_get_name ((GDBusProxy *) self), g_dbus_proxy_get_object_path ((GDBusProxy *) self), "com.Gwibber.Service", "Start");
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_message_set_body (_message, _arguments);
	_reply_message = g_dbus_connection_send_message_with_reply_sync (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, g_dbus_proxy_get_default_timeout ((GDBusProxy *) self), NULL, NULL, error);
	g_object_unref (_message);
	if (!_reply_message) {
		return;
	}
	if (g_dbus_message_to_gerror (_reply_message, error)) {
		g_object_unref (_reply_message);
		return;
	}
	g_object_unref (_reply_message);
}


static void service_interface_proxy_Quit (ServiceInterface* self, GError** error) {
	GDBusMessage *_message;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	GDBusMessage *_reply_message;
	G_IO_ERROR;
	_message = g_dbus_message_new_method_call (g_dbus_proxy_get_name ((GDBusProxy *) self), g_dbus_proxy_get_object_path ((GDBusProxy *) self), "com.Gwibber.Service", "Quit");
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_message_set_body (_message, _arguments);
	_reply_message = g_dbus_connection_send_message_with_reply_sync (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, g_dbus_proxy_get_default_timeout ((GDBusProxy *) self), NULL, NULL, error);
	g_object_unref (_message);
	if (!_reply_message) {
		return;
	}
	if (g_dbus_message_to_gerror (_reply_message, error)) {
		g_object_unref (_reply_message);
		return;
	}
	g_object_unref (_reply_message);
}


static void service_interface_proxy_Refresh (ServiceInterface* self, GError** error) {
	GDBusMessage *_message;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	GDBusMessage *_reply_message;
	G_IO_ERROR;
	_message = g_dbus_message_new_method_call (g_dbus_proxy_get_name ((GDBusProxy *) self), g_dbus_proxy_get_object_path ((GDBusProxy *) self), "com.Gwibber.Service", "Refresh");
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_message_set_body (_message, _arguments);
	_reply_message = g_dbus_connection_send_message_with_reply_sync (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, g_dbus_proxy_get_default_timeout ((GDBusProxy *) self), NULL, NULL, error);
	g_object_unref (_message);
	if (!_reply_message) {
		return;
	}
	if (g_dbus_message_to_gerror (_reply_message, error)) {
		g_object_unref (_reply_message);
		return;
	}
	g_object_unref (_reply_message);
}


static void service_interface_proxy_SendMessage (ServiceInterface* self, const gchar* msg, GError** error) {
	GDBusMessage *_message;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	GDBusMessage *_reply_message;
	G_IO_ERROR;
	_message = g_dbus_message_new_method_call (g_dbus_proxy_get_name ((GDBusProxy *) self), g_dbus_proxy_get_object_path ((GDBusProxy *) self), "com.Gwibber.Service", "SendMessage");
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string (msg));
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_message_set_body (_message, _arguments);
	_reply_message = g_dbus_connection_send_message_with_reply_sync (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, g_dbus_proxy_get_default_timeout ((GDBusProxy *) self), NULL, NULL, error);
	g_object_unref (_message);
	if (!_reply_message) {
		return;
	}
	if (g_dbus_message_to_gerror (_reply_message, error)) {
		g_object_unref (_reply_message);
		return;
	}
	g_object_unref (_reply_message);
}


static void service_interface_proxy_Send (ServiceInterface* self, const gchar* msg, GError** error) {
	GDBusMessage *_message;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	GDBusMessage *_reply_message;
	G_IO_ERROR;
	_message = g_dbus_message_new_method_call (g_dbus_proxy_get_name ((GDBusProxy *) self), g_dbus_proxy_get_object_path ((GDBusProxy *) self), "com.Gwibber.Service", "Send");
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string (msg));
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_message_set_body (_message, _arguments);
	_reply_message = g_dbus_connection_send_message_with_reply_sync (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, g_dbus_proxy_get_default_timeout ((GDBusProxy *) self), NULL, NULL, error);
	g_object_unref (_message);
	if (!_reply_message) {
		return;
	}
	if (g_dbus_message_to_gerror (_reply_message, error)) {
		g_object_unref (_reply_message);
		return;
	}
	g_object_unref (_reply_message);
}


static void service_interface_proxy_Like (ServiceInterface* self, const gchar* mid, const gchar* account, GError** error) {
	GDBusMessage *_message;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	GDBusMessage *_reply_message;
	G_IO_ERROR;
	_message = g_dbus_message_new_method_call (g_dbus_proxy_get_name ((GDBusProxy *) self), g_dbus_proxy_get_object_path ((GDBusProxy *) self), "com.Gwibber.Service", "Like");
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string (mid));
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string (account));
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_message_set_body (_message, _arguments);
	_reply_message = g_dbus_connection_send_message_with_reply_sync (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, g_dbus_proxy_get_default_timeout ((GDBusProxy *) self), NULL, NULL, error);
	g_object_unref (_message);
	if (!_reply_message) {
		return;
	}
	if (g_dbus_message_to_gerror (_reply_message, error)) {
		g_object_unref (_reply_message);
		return;
	}
	g_object_unref (_reply_message);
}


static void service_interface_proxy_UnLike (ServiceInterface* self, const gchar* mid, const gchar* account, GError** error) {
	GDBusMessage *_message;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	GDBusMessage *_reply_message;
	G_IO_ERROR;
	_message = g_dbus_message_new_method_call (g_dbus_proxy_get_name ((GDBusProxy *) self), g_dbus_proxy_get_object_path ((GDBusProxy *) self), "com.Gwibber.Service", "UnLike");
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string (mid));
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string (account));
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_message_set_body (_message, _arguments);
	_reply_message = g_dbus_connection_send_message_with_reply_sync (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, g_dbus_proxy_get_default_timeout ((GDBusProxy *) self), NULL, NULL, error);
	g_object_unref (_message);
	if (!_reply_message) {
		return;
	}
	if (g_dbus_message_to_gerror (_reply_message, error)) {
		g_object_unref (_reply_message);
		return;
	}
	g_object_unref (_reply_message);
}


static void service_interface_proxy_Retweet (ServiceInterface* self, const gchar* mid, const gchar* account, GError** error) {
	GDBusMessage *_message;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	GDBusMessage *_reply_message;
	G_IO_ERROR;
	_message = g_dbus_message_new_method_call (g_dbus_proxy_get_name ((GDBusProxy *) self), g_dbus_proxy_get_object_path ((GDBusProxy *) self), "com.Gwibber.Service", "Retweet");
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string (mid));
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string (account));
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_message_set_body (_message, _arguments);
	_reply_message = g_dbus_connection_send_message_with_reply_sync (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, g_dbus_proxy_get_default_timeout ((GDBusProxy *) self), NULL, NULL, error);
	g_object_unref (_message);
	if (!_reply_message) {
		return;
	}
	if (g_dbus_message_to_gerror (_reply_message, error)) {
		g_object_unref (_reply_message);
		return;
	}
	g_object_unref (_reply_message);
}


static void service_interface_proxy_PerformOp (ServiceInterface* self, const gchar* op, GError** error) {
	GDBusMessage *_message;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	GDBusMessage *_reply_message;
	G_IO_ERROR;
	_message = g_dbus_message_new_method_call (g_dbus_proxy_get_name ((GDBusProxy *) self), g_dbus_proxy_get_object_path ((GDBusProxy *) self), "com.Gwibber.Service", "PerformOp");
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string (op));
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_message_set_body (_message, _arguments);
	_reply_message = g_dbus_connection_send_message_with_reply_sync (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, g_dbus_proxy_get_default_timeout ((GDBusProxy *) self), NULL, NULL, error);
	g_object_unref (_message);
	if (!_reply_message) {
		return;
	}
	if (g_dbus_message_to_gerror (_reply_message, error)) {
		g_object_unref (_reply_message);
		return;
	}
	g_object_unref (_reply_message);
}


static void service_interface_proxy_UpdateIndicators (ServiceInterface* self, const gchar* stream, GError** error) {
	GDBusMessage *_message;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	GDBusMessage *_reply_message;
	G_IO_ERROR;
	_message = g_dbus_message_new_method_call (g_dbus_proxy_get_name ((GDBusProxy *) self), g_dbus_proxy_get_object_path ((GDBusProxy *) self), "com.Gwibber.Service", "UpdateIndicators");
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string (stream));
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_message_set_body (_message, _arguments);
	_reply_message = g_dbus_connection_send_message_with_reply_sync (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, g_dbus_proxy_get_default_timeout ((GDBusProxy *) self), NULL, NULL, error);
	g_object_unref (_message);
	if (!_reply_message) {
		return;
	}
	if (g_dbus_message_to_gerror (_reply_message, error)) {
		g_object_unref (_reply_message);
		return;
	}
	g_object_unref (_reply_message);
}


static gchar* service_interface_proxy_GetAvatarPath (ServiceInterface* self, const gchar* url, GError** error) {
	GDBusMessage *_message;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	GDBusMessage *_reply_message;
	GVariant *_reply;
	GVariantIter _reply_iter;
	gchar* _result;
	GVariant* _tmp9_;
	G_IO_ERROR;
	_message = g_dbus_message_new_method_call (g_dbus_proxy_get_name ((GDBusProxy *) self), g_dbus_proxy_get_object_path ((GDBusProxy *) self), "com.Gwibber.Service", "GetAvatarPath");
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string (url));
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_message_set_body (_message, _arguments);
	_reply_message = g_dbus_connection_send_message_with_reply_sync (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, g_dbus_proxy_get_default_timeout ((GDBusProxy *) self), NULL, NULL, error);
	g_object_unref (_message);
	if (!_reply_message) {
		return NULL;
	}
	if (g_dbus_message_to_gerror (_reply_message, error)) {
		g_object_unref (_reply_message);
		return NULL;
	}
	_reply = g_dbus_message_get_body (_reply_message);
	g_variant_iter_init (&_reply_iter, _reply);
	_tmp9_ = g_variant_iter_next_value (&_reply_iter);
	_result = g_variant_dup_string (_tmp9_, NULL);
	g_variant_unref (_tmp9_);
	g_object_unref (_reply_message);
	return _result;
}


static gchar* service_interface_proxy_GetFeatures (ServiceInterface* self, GError** error) {
	GDBusMessage *_message;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	GDBusMessage *_reply_message;
	GVariant *_reply;
	GVariantIter _reply_iter;
	gchar* _result;
	GVariant* _tmp10_;
	G_IO_ERROR;
	_message = g_dbus_message_new_method_call (g_dbus_proxy_get_name ((GDBusProxy *) self), g_dbus_proxy_get_object_path ((GDBusProxy *) self), "com.Gwibber.Service", "GetFeatures");
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_message_set_body (_message, _arguments);
	_reply_message = g_dbus_connection_send_message_with_reply_sync (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, g_dbus_proxy_get_default_timeout ((GDBusProxy *) self), NULL, NULL, error);
	g_object_unref (_message);
	if (!_reply_message) {
		return NULL;
	}
	if (g_dbus_message_to_gerror (_reply_message, error)) {
		g_object_unref (_reply_message);
		return NULL;
	}
	_reply = g_dbus_message_get_body (_reply_message);
	g_variant_iter_init (&_reply_iter, _reply);
	_tmp10_ = g_variant_iter_next_value (&_reply_iter);
	_result = g_variant_dup_string (_tmp10_, NULL);
	g_variant_unref (_tmp10_);
	g_object_unref (_reply_message);
	return _result;
}


static gchar* service_interface_proxy_GetServices (ServiceInterface* self, GError** error) {
	GDBusMessage *_message;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	GDBusMessage *_reply_message;
	GVariant *_reply;
	GVariantIter _reply_iter;
	gchar* _result;
	GVariant* _tmp11_;
	G_IO_ERROR;
	_message = g_dbus_message_new_method_call (g_dbus_proxy_get_name ((GDBusProxy *) self), g_dbus_proxy_get_object_path ((GDBusProxy *) self), "com.Gwibber.Service", "GetServices");
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_message_set_body (_message, _arguments);
	_reply_message = g_dbus_connection_send_message_with_reply_sync (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, g_dbus_proxy_get_default_timeout ((GDBusProxy *) self), NULL, NULL, error);
	g_object_unref (_message);
	if (!_reply_message) {
		return NULL;
	}
	if (g_dbus_message_to_gerror (_reply_message, error)) {
		g_object_unref (_reply_message);
		return NULL;
	}
	_reply = g_dbus_message_get_body (_reply_message);
	g_variant_iter_init (&_reply_iter, _reply);
	_tmp11_ = g_variant_iter_next_value (&_reply_iter);
	_result = g_variant_dup_string (_tmp11_, NULL);
	g_variant_unref (_tmp11_);
	g_object_unref (_reply_message);
	return _result;
}


static gchar* service_interface_proxy_GetVersion (ServiceInterface* self, GError** error) {
	GDBusMessage *_message;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	GDBusMessage *_reply_message;
	GVariant *_reply;
	GVariantIter _reply_iter;
	gchar* _result;
	GVariant* _tmp12_;
	G_IO_ERROR;
	_message = g_dbus_message_new_method_call (g_dbus_proxy_get_name ((GDBusProxy *) self), g_dbus_proxy_get_object_path ((GDBusProxy *) self), "com.Gwibber.Service", "GetVersion");
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_message_set_body (_message, _arguments);
	_reply_message = g_dbus_connection_send_message_with_reply_sync (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, g_dbus_proxy_get_default_timeout ((GDBusProxy *) self), NULL, NULL, error);
	g_object_unref (_message);
	if (!_reply_message) {
		return NULL;
	}
	if (g_dbus_message_to_gerror (_reply_message, error)) {
		g_object_unref (_reply_message);
		return NULL;
	}
	_reply = g_dbus_message_get_body (_reply_message);
	g_variant_iter_init (&_reply_iter, _reply);
	_tmp12_ = g_variant_iter_next_value (&_reply_iter);
	_result = g_variant_dup_string (_tmp12_, NULL);
	g_variant_unref (_tmp12_);
	g_object_unref (_reply_message);
	return _result;
}


static void service_interface_proxy_service_interface_interface_init (ServiceInterfaceIface* iface) {
	iface->Start = service_interface_proxy_Start;
	iface->Quit = service_interface_proxy_Quit;
	iface->Refresh = service_interface_proxy_Refresh;
	iface->SendMessage = service_interface_proxy_SendMessage;
	iface->Send = service_interface_proxy_Send;
	iface->Like = service_interface_proxy_Like;
	iface->UnLike = service_interface_proxy_UnLike;
	iface->Retweet = service_interface_proxy_Retweet;
	iface->PerformOp = service_interface_proxy_PerformOp;
	iface->UpdateIndicators = service_interface_proxy_UpdateIndicators;
	iface->GetAvatarPath = service_interface_proxy_GetAvatarPath;
	iface->GetFeatures = service_interface_proxy_GetFeatures;
	iface->GetServices = service_interface_proxy_GetServices;
	iface->GetVersion = service_interface_proxy_GetVersion;
}


static void _dbus_service_interface_Start (ServiceInterface* self, GVariant* parameters, GDBusMethodInvocation* invocation) {
	GError* error = NULL;
	GVariantIter _arguments_iter;
	GDBusMessage* _reply_message;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	g_variant_iter_init (&_arguments_iter, parameters);
	service_interface_Start (self, &error);
	if (error) {
		g_dbus_method_invocation_return_gerror (invocation, error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
}


static void _dbus_service_interface_Quit (ServiceInterface* self, GVariant* parameters, GDBusMethodInvocation* invocation) {
	GError* error = NULL;
	GVariantIter _arguments_iter;
	GDBusMessage* _reply_message;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	g_variant_iter_init (&_arguments_iter, parameters);
	service_interface_Quit (self, &error);
	if (error) {
		g_dbus_method_invocation_return_gerror (invocation, error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
}


static void _dbus_service_interface_Refresh (ServiceInterface* self, GVariant* parameters, GDBusMethodInvocation* invocation) {
	GError* error = NULL;
	GVariantIter _arguments_iter;
	GDBusMessage* _reply_message;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	g_variant_iter_init (&_arguments_iter, parameters);
	service_interface_Refresh (self, &error);
	if (error) {
		g_dbus_method_invocation_return_gerror (invocation, error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
}


static void _dbus_service_interface_SendMessage (ServiceInterface* self, GVariant* parameters, GDBusMethodInvocation* invocation) {
	GError* error = NULL;
	GVariantIter _arguments_iter;
	gchar* msg = NULL;
	GVariant* _tmp13_;
	GDBusMessage* _reply_message;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	g_variant_iter_init (&_arguments_iter, parameters);
	_tmp13_ = g_variant_iter_next_value (&_arguments_iter);
	msg = g_variant_dup_string (_tmp13_, NULL);
	g_variant_unref (_tmp13_);
	service_interface_SendMessage (self, msg, &error);
	if (error) {
		g_dbus_method_invocation_return_gerror (invocation, error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	_g_free0 (msg);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
}


static void _dbus_service_interface_Send (ServiceInterface* self, GVariant* parameters, GDBusMethodInvocation* invocation) {
	GError* error = NULL;
	GVariantIter _arguments_iter;
	gchar* msg = NULL;
	GVariant* _tmp14_;
	GDBusMessage* _reply_message;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	g_variant_iter_init (&_arguments_iter, parameters);
	_tmp14_ = g_variant_iter_next_value (&_arguments_iter);
	msg = g_variant_dup_string (_tmp14_, NULL);
	g_variant_unref (_tmp14_);
	service_interface_Send (self, msg, &error);
	if (error) {
		g_dbus_method_invocation_return_gerror (invocation, error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	_g_free0 (msg);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
}


static void _dbus_service_interface_Like (ServiceInterface* self, GVariant* parameters, GDBusMethodInvocation* invocation) {
	GError* error = NULL;
	GVariantIter _arguments_iter;
	gchar* mid = NULL;
	GVariant* _tmp15_;
	gchar* account = NULL;
	GVariant* _tmp16_;
	GDBusMessage* _reply_message;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	g_variant_iter_init (&_arguments_iter, parameters);
	_tmp15_ = g_variant_iter_next_value (&_arguments_iter);
	mid = g_variant_dup_string (_tmp15_, NULL);
	g_variant_unref (_tmp15_);
	_tmp16_ = g_variant_iter_next_value (&_arguments_iter);
	account = g_variant_dup_string (_tmp16_, NULL);
	g_variant_unref (_tmp16_);
	service_interface_Like (self, mid, account, &error);
	if (error) {
		g_dbus_method_invocation_return_gerror (invocation, error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	_g_free0 (mid);
	_g_free0 (account);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
}


static void _dbus_service_interface_UnLike (ServiceInterface* self, GVariant* parameters, GDBusMethodInvocation* invocation) {
	GError* error = NULL;
	GVariantIter _arguments_iter;
	gchar* mid = NULL;
	GVariant* _tmp17_;
	gchar* account = NULL;
	GVariant* _tmp18_;
	GDBusMessage* _reply_message;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	g_variant_iter_init (&_arguments_iter, parameters);
	_tmp17_ = g_variant_iter_next_value (&_arguments_iter);
	mid = g_variant_dup_string (_tmp17_, NULL);
	g_variant_unref (_tmp17_);
	_tmp18_ = g_variant_iter_next_value (&_arguments_iter);
	account = g_variant_dup_string (_tmp18_, NULL);
	g_variant_unref (_tmp18_);
	service_interface_UnLike (self, mid, account, &error);
	if (error) {
		g_dbus_method_invocation_return_gerror (invocation, error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	_g_free0 (mid);
	_g_free0 (account);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
}


static void _dbus_service_interface_Retweet (ServiceInterface* self, GVariant* parameters, GDBusMethodInvocation* invocation) {
	GError* error = NULL;
	GVariantIter _arguments_iter;
	gchar* mid = NULL;
	GVariant* _tmp19_;
	gchar* account = NULL;
	GVariant* _tmp20_;
	GDBusMessage* _reply_message;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	g_variant_iter_init (&_arguments_iter, parameters);
	_tmp19_ = g_variant_iter_next_value (&_arguments_iter);
	mid = g_variant_dup_string (_tmp19_, NULL);
	g_variant_unref (_tmp19_);
	_tmp20_ = g_variant_iter_next_value (&_arguments_iter);
	account = g_variant_dup_string (_tmp20_, NULL);
	g_variant_unref (_tmp20_);
	service_interface_Retweet (self, mid, account, &error);
	if (error) {
		g_dbus_method_invocation_return_gerror (invocation, error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	_g_free0 (mid);
	_g_free0 (account);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
}


static void _dbus_service_interface_PerformOp (ServiceInterface* self, GVariant* parameters, GDBusMethodInvocation* invocation) {
	GError* error = NULL;
	GVariantIter _arguments_iter;
	gchar* op = NULL;
	GVariant* _tmp21_;
	GDBusMessage* _reply_message;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	g_variant_iter_init (&_arguments_iter, parameters);
	_tmp21_ = g_variant_iter_next_value (&_arguments_iter);
	op = g_variant_dup_string (_tmp21_, NULL);
	g_variant_unref (_tmp21_);
	service_interface_PerformOp (self, op, &error);
	if (error) {
		g_dbus_method_invocation_return_gerror (invocation, error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	_g_free0 (op);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
}


static void _dbus_service_interface_UpdateIndicators (ServiceInterface* self, GVariant* parameters, GDBusMethodInvocation* invocation) {
	GError* error = NULL;
	GVariantIter _arguments_iter;
	gchar* stream = NULL;
	GVariant* _tmp22_;
	GDBusMessage* _reply_message;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	g_variant_iter_init (&_arguments_iter, parameters);
	_tmp22_ = g_variant_iter_next_value (&_arguments_iter);
	stream = g_variant_dup_string (_tmp22_, NULL);
	g_variant_unref (_tmp22_);
	service_interface_UpdateIndicators (self, stream, &error);
	if (error) {
		g_dbus_method_invocation_return_gerror (invocation, error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	_g_free0 (stream);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
}


static void _dbus_service_interface_GetAvatarPath (ServiceInterface* self, GVariant* parameters, GDBusMethodInvocation* invocation) {
	GError* error = NULL;
	GVariantIter _arguments_iter;
	gchar* url = NULL;
	GVariant* _tmp23_;
	GDBusMessage* _reply_message;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	gchar* result;
	g_variant_iter_init (&_arguments_iter, parameters);
	_tmp23_ = g_variant_iter_next_value (&_arguments_iter);
	url = g_variant_dup_string (_tmp23_, NULL);
	g_variant_unref (_tmp23_);
	result = service_interface_GetAvatarPath (self, url, &error);
	if (error) {
		g_dbus_method_invocation_return_gerror (invocation, error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_reply_builder, g_variant_new_string (result));
	_g_free0 (result);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	_g_free0 (url);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
}


static void _dbus_service_interface_GetFeatures (ServiceInterface* self, GVariant* parameters, GDBusMethodInvocation* invocation) {
	GError* error = NULL;
	GVariantIter _arguments_iter;
	GDBusMessage* _reply_message;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	gchar* result;
	g_variant_iter_init (&_arguments_iter, parameters);
	result = service_interface_GetFeatures (self, &error);
	if (error) {
		g_dbus_method_invocation_return_gerror (invocation, error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_reply_builder, g_variant_new_string (result));
	_g_free0 (result);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
}


static void _dbus_service_interface_GetServices (ServiceInterface* self, GVariant* parameters, GDBusMethodInvocation* invocation) {
	GError* error = NULL;
	GVariantIter _arguments_iter;
	GDBusMessage* _reply_message;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	gchar* result;
	g_variant_iter_init (&_arguments_iter, parameters);
	result = service_interface_GetServices (self, &error);
	if (error) {
		g_dbus_method_invocation_return_gerror (invocation, error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_reply_builder, g_variant_new_string (result));
	_g_free0 (result);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
}


static void _dbus_service_interface_GetVersion (ServiceInterface* self, GVariant* parameters, GDBusMethodInvocation* invocation) {
	GError* error = NULL;
	GVariantIter _arguments_iter;
	GDBusMessage* _reply_message;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	gchar* result;
	g_variant_iter_init (&_arguments_iter, parameters);
	result = service_interface_GetVersion (self, &error);
	if (error) {
		g_dbus_method_invocation_return_gerror (invocation, error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_reply_builder, g_variant_new_string (result));
	_g_free0 (result);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
}


static void service_interface_dbus_interface_method_call (GDBusConnection* connection, const gchar* sender, const gchar* object_path, const gchar* interface_name, const gchar* method_name, GVariant* parameters, GDBusMethodInvocation* invocation, gpointer user_data) {
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	if (strcmp (method_name, "Start") == 0) {
		_dbus_service_interface_Start (object, parameters, invocation);
	} else if (strcmp (method_name, "Quit") == 0) {
		_dbus_service_interface_Quit (object, parameters, invocation);
	} else if (strcmp (method_name, "Refresh") == 0) {
		_dbus_service_interface_Refresh (object, parameters, invocation);
	} else if (strcmp (method_name, "SendMessage") == 0) {
		_dbus_service_interface_SendMessage (object, parameters, invocation);
	} else if (strcmp (method_name, "Send") == 0) {
		_dbus_service_interface_Send (object, parameters, invocation);
	} else if (strcmp (method_name, "Like") == 0) {
		_dbus_service_interface_Like (object, parameters, invocation);
	} else if (strcmp (method_name, "UnLike") == 0) {
		_dbus_service_interface_UnLike (object, parameters, invocation);
	} else if (strcmp (method_name, "Retweet") == 0) {
		_dbus_service_interface_Retweet (object, parameters, invocation);
	} else if (strcmp (method_name, "PerformOp") == 0) {
		_dbus_service_interface_PerformOp (object, parameters, invocation);
	} else if (strcmp (method_name, "UpdateIndicators") == 0) {
		_dbus_service_interface_UpdateIndicators (object, parameters, invocation);
	} else if (strcmp (method_name, "GetAvatarPath") == 0) {
		_dbus_service_interface_GetAvatarPath (object, parameters, invocation);
	} else if (strcmp (method_name, "GetFeatures") == 0) {
		_dbus_service_interface_GetFeatures (object, parameters, invocation);
	} else if (strcmp (method_name, "GetServices") == 0) {
		_dbus_service_interface_GetServices (object, parameters, invocation);
	} else if (strcmp (method_name, "GetVersion") == 0) {
		_dbus_service_interface_GetVersion (object, parameters, invocation);
	} else {
		g_object_unref (invocation);
	}
}


static GVariant* service_interface_dbus_interface_get_property (GDBusConnection* connection, const gchar* sender, const gchar* object_path, const gchar* interface_name, const gchar* property_name, GError** error, gpointer user_data) {
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	return NULL;
}


static gboolean service_interface_dbus_interface_set_property (GDBusConnection* connection, const gchar* sender, const gchar* object_path, const gchar* interface_name, const gchar* property_name, GVariant* value, GError** error, gpointer user_data) {
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	return FALSE;
}


static void _dbus_service_interface_loading_started (GObject* _sender, gpointer* _data) {
	GDBusConnection * _connection;
	const gchar * _path;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	_connection = _data[1];
	_path = _data[2];
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_connection_emit_signal (_connection, NULL, _path, "com.Gwibber.Service", "LoadingStarted", _arguments, NULL);
}


static void _dbus_service_interface_loading_complete (GObject* _sender, gpointer* _data) {
	GDBusConnection * _connection;
	const gchar * _path;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	_connection = _data[1];
	_path = _data[2];
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_connection_emit_signal (_connection, NULL, _path, "com.Gwibber.Service", "LoadingComplete", _arguments, NULL);
}


static void _dbus_service_interface_error (GObject* _sender, const gchar* error_str, gpointer* _data) {
	GDBusConnection * _connection;
	const gchar * _path;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	_connection = _data[1];
	_path = _data[2];
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string (error_str));
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_connection_emit_signal (_connection, NULL, _path, "com.Gwibber.Service", "Error", _arguments, NULL);
}


guint service_interface_register_object (gpointer object, GDBusConnection* connection, const gchar* path, GError** error) {
	guint result;
	gpointer *data;
	data = g_new (gpointer, 3);
	data[0] = g_object_ref (object);
	data[1] = g_object_ref (connection);
	data[2] = g_strdup (path);
	result = g_dbus_connection_register_object (connection, path, (GDBusInterfaceInfo *) (&_service_interface_dbus_interface_info), &_service_interface_dbus_interface_vtable, data, _service_interface_unregister_object, error);
	if (!result) {
		return 0;
	}
	g_signal_connect (object, "loading-started", (GCallback) _dbus_service_interface_loading_started, data);
	g_signal_connect (object, "loading-complete", (GCallback) _dbus_service_interface_loading_complete, data);
	g_signal_connect (object, "error", (GCallback) _dbus_service_interface_error, data);
	return result;
}


static void _service_interface_unregister_object (gpointer user_data) {
	gpointer* data;
	data = user_data;
	g_signal_handlers_disconnect_by_func (data[0], _dbus_service_interface_loading_started, data);
	g_signal_handlers_disconnect_by_func (data[0], _dbus_service_interface_loading_complete, data);
	g_signal_handlers_disconnect_by_func (data[0], _dbus_service_interface_error, data);
	g_object_unref (data[0]);
	g_object_unref (data[1]);
	g_free (data[2]);
	g_free (data);
}


void gwibber_service_service_available (GwibberService* self, gboolean is_up) {
	gboolean _tmp0_;
#line 117 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
	g_return_if_fail (self != NULL);
#line 119 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
	_tmp0_ = is_up;
#line 119 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
	g_signal_emit_by_name (self, "is-available", _tmp0_);
#line 1363 "service.c"
}


void gwibber_service_on_loading_started (GwibberService* self) {
#line 122 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
	g_return_if_fail (self != NULL);
#line 124 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
	g_signal_emit_by_name (self, "loading-started");
#line 1372 "service.c"
}


void gwibber_service_on_loading_complete (GwibberService* self) {
#line 127 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
	g_return_if_fail (self != NULL);
#line 129 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
	g_signal_emit_by_name (self, "loading-complete");
#line 1381 "service.c"
}


static JsonObject* _vala_JsonObject_copy (JsonObject* self) {
#line 138 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
	return g_boxed_copy (json_object_get_type (), self);
#line 1388 "service.c"
}


static gpointer __vala_JsonObject_copy0 (gpointer self) {
#line 138 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
	return self ? _vala_JsonObject_copy (self) : NULL;
#line 1395 "service.c"
}


static void _vala_JsonObject_free (JsonObject* self) {
#line 135 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
	g_boxed_free (json_object_get_type (), self);
#line 1402 "service.c"
}


void gwibber_service_on_error (GwibberService* self, const gchar* error_str) {
	GError * _inner_error_ = NULL;
#line 132 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
	g_return_if_fail (self != NULL);
#line 132 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
	g_return_if_fail (error_str != NULL);
#line 1412 "service.c"
	{
		JsonParser* _tmp0_;
		JsonParser* parser;
		const gchar* _tmp1_;
		JsonNode* _tmp2_ = NULL;
		JsonObject* _tmp3_ = NULL;
		JsonObject* _tmp4_;
		JsonObject* root_object;
		JsonObject* _tmp5_;
		JsonNode* _tmp6_ = NULL;
		JsonObject* _tmp7_ = NULL;
		JsonObject* _tmp8_;
		JsonObject* error_object;
		JsonObject* _tmp9_;
		JsonNode* _tmp10_ = NULL;
		JsonObject* _tmp11_ = NULL;
		JsonObject* _tmp12_;
		JsonObject* account_object;
		JsonObject* _tmp13_;
		JsonNode* _tmp14_ = NULL;
		const gchar* _tmp15_ = NULL;
		gchar* _tmp16_;
		gchar* id;
		JsonObject* _tmp17_;
		JsonNode* _tmp18_ = NULL;
		const gchar* _tmp19_ = NULL;
		gchar* _tmp20_;
		gchar* type;
		JsonObject* _tmp21_;
		JsonNode* _tmp22_ = NULL;
		const gchar* _tmp23_ = NULL;
		gchar* _tmp24_;
		gchar* message;
		const gchar* _tmp25_;
		const gchar* _tmp26_;
		const gchar* _tmp27_;
#line 136 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		_tmp0_ = json_parser_new ();
#line 136 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		parser = _tmp0_;
#line 137 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		_tmp1_ = error_str;
#line 137 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		json_parser_load_from_data (parser, _tmp1_, (gssize) (-1), &_inner_error_);
#line 137 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		if (_inner_error_ != NULL) {
#line 137 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
			_g_object_unref0 (parser);
#line 1461 "service.c"
			goto __catch11_g_error;
		}
#line 138 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		_tmp2_ = json_parser_get_root (parser);
#line 138 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		_tmp3_ = json_node_get_object (_tmp2_);
#line 138 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		_tmp4_ = __vala_JsonObject_copy0 (_tmp3_);
#line 138 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		root_object = _tmp4_;
#line 139 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		_tmp5_ = root_object;
#line 139 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		_tmp6_ = json_object_get_member (_tmp5_, "error");
#line 139 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		_tmp7_ = json_node_get_object (_tmp6_);
#line 139 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		_tmp8_ = __vala_JsonObject_copy0 (_tmp7_);
#line 139 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		error_object = _tmp8_;
#line 140 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		_tmp9_ = error_object;
#line 140 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		_tmp10_ = json_object_get_member (_tmp9_, "account");
#line 140 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		_tmp11_ = json_node_get_object (_tmp10_);
#line 140 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		_tmp12_ = __vala_JsonObject_copy0 (_tmp11_);
#line 140 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		account_object = _tmp12_;
#line 141 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		_tmp13_ = account_object;
#line 141 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		_tmp14_ = json_object_get_member (_tmp13_, "id");
#line 141 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		_tmp15_ = json_node_get_string (_tmp14_);
#line 141 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		_tmp16_ = g_strdup (_tmp15_);
#line 141 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		id = _tmp16_;
#line 142 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		_tmp17_ = error_object;
#line 142 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		_tmp18_ = json_object_get_member (_tmp17_, "type");
#line 142 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		_tmp19_ = json_node_get_string (_tmp18_);
#line 142 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		_tmp20_ = g_strdup (_tmp19_);
#line 142 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		type = _tmp20_;
#line 143 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		_tmp21_ = error_object;
#line 143 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		_tmp22_ = json_object_get_member (_tmp21_, "message");
#line 143 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		_tmp23_ = json_node_get_string (_tmp22_);
#line 143 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		_tmp24_ = g_strdup (_tmp23_);
#line 143 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		message = _tmp24_;
#line 144 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		_tmp25_ = id;
#line 144 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		_tmp26_ = type;
#line 144 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		_tmp27_ = message;
#line 144 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		g_signal_emit_by_name (self, "error", _tmp25_, _tmp26_, _tmp27_);
#line 135 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		_g_free0 (message);
#line 135 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		_g_free0 (type);
#line 135 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		_g_free0 (id);
#line 135 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		__vala_JsonObject_free0 (account_object);
#line 135 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		__vala_JsonObject_free0 (error_object);
#line 135 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		__vala_JsonObject_free0 (root_object);
#line 135 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		_g_object_unref0 (parser);
#line 1544 "service.c"
	}
	goto __finally11;
	__catch11_g_error:
	{
		GError* e = NULL;
		GError* _tmp28_;
		const gchar* _tmp29_;
#line 135 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		e = _inner_error_;
#line 135 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		_inner_error_ = NULL;
#line 146 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		_tmp28_ = e;
#line 146 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		_tmp29_ = _tmp28_->message;
#line 146 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		g_warning ("service.vala:146: %s", _tmp29_);
#line 135 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		_g_error_free0 (e);
#line 1564 "service.c"
	}
	__finally11:
#line 135 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
	if (_inner_error_ != NULL) {
#line 135 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 135 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		g_clear_error (&_inner_error_);
#line 135 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		return;
#line 1575 "service.c"
	}
}


/**
            start:
        */
void gwibber_service_start (GwibberService* self) {
	GError * _inner_error_ = NULL;
#line 153 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
	g_return_if_fail (self != NULL);
#line 1587 "service.c"
	{
		ServiceInterface* _tmp0_;
#line 156 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		_tmp0_ = self->priv->service;
#line 156 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		service_interface_Start (_tmp0_, &_inner_error_);
#line 156 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		if (_inner_error_ != NULL) {
#line 156 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
			if (_inner_error_->domain == G_IO_ERROR) {
#line 1598 "service.c"
				goto __catch12_g_io_error;
			}
#line 156 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 156 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
			g_clear_error (&_inner_error_);
#line 156 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
			return;
#line 1607 "service.c"
		}
	}
	goto __finally12;
	__catch12_g_io_error:
	{
		GError* e = NULL;
		GError* _tmp1_;
		const gchar* _tmp2_;
#line 155 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		e = _inner_error_;
#line 155 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		_inner_error_ = NULL;
#line 158 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		_tmp1_ = e;
#line 158 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		_tmp2_ = _tmp1_->message;
#line 158 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		g_warning ("service.vala:158: %s", _tmp2_);
#line 155 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		_g_error_free0 (e);
#line 1628 "service.c"
	}
	__finally12:
#line 155 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
	if (_inner_error_ != NULL) {
#line 155 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 155 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		g_clear_error (&_inner_error_);
#line 155 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		return;
#line 1639 "service.c"
	}
}


/**
            quit:

            Tells the gwibber service to shutdown.
        */
void gwibber_service_quit (GwibberService* self) {
	GError * _inner_error_ = NULL;
#line 167 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
	g_return_if_fail (self != NULL);
#line 1653 "service.c"
	{
		ServiceInterface* _tmp0_;
#line 170 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		_tmp0_ = self->priv->service;
#line 170 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		service_interface_Quit (_tmp0_, &_inner_error_);
#line 170 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		if (_inner_error_ != NULL) {
#line 170 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
			if (_inner_error_->domain == G_IO_ERROR) {
#line 1664 "service.c"
				goto __catch13_g_io_error;
			}
#line 170 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 170 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
			g_clear_error (&_inner_error_);
#line 170 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
			return;
#line 1673 "service.c"
		}
	}
	goto __finally13;
	__catch13_g_io_error:
	{
		GError* e = NULL;
		GError* _tmp1_;
		const gchar* _tmp2_;
#line 169 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		e = _inner_error_;
#line 169 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		_inner_error_ = NULL;
#line 172 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		_tmp1_ = e;
#line 172 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		_tmp2_ = _tmp1_->message;
#line 172 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		g_warning ("service.vala:172: %s", _tmp2_);
#line 169 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		_g_error_free0 (e);
#line 1694 "service.c"
	}
	__finally13:
#line 169 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
	if (_inner_error_ != NULL) {
#line 169 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 169 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		g_clear_error (&_inner_error_);
#line 169 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		return;
#line 1705 "service.c"
	}
}


/**
            refresh:

            Tells the gwibber service to perform a refresh.
        */
void gwibber_service_refresh (GwibberService* self) {
	GError * _inner_error_ = NULL;
#line 181 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
	g_return_if_fail (self != NULL);
#line 1719 "service.c"
	{
		ServiceInterface* _tmp0_;
#line 184 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		_tmp0_ = self->priv->service;
#line 184 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		service_interface_Refresh (_tmp0_, &_inner_error_);
#line 184 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		if (_inner_error_ != NULL) {
#line 184 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
			if (_inner_error_->domain == G_IO_ERROR) {
#line 1730 "service.c"
				goto __catch14_g_io_error;
			}
#line 184 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 184 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
			g_clear_error (&_inner_error_);
#line 184 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
			return;
#line 1739 "service.c"
		}
	}
	goto __finally14;
	__catch14_g_io_error:
	{
		GError* e = NULL;
		GError* _tmp1_;
		const gchar* _tmp2_;
#line 183 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		e = _inner_error_;
#line 183 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		_inner_error_ = NULL;
#line 186 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		_tmp1_ = e;
#line 186 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		_tmp2_ = _tmp1_->message;
#line 186 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		g_warning ("service.vala:186: %s", _tmp2_);
#line 183 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		_g_error_free0 (e);
#line 1760 "service.c"
	}
	__finally14:
#line 183 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
	if (_inner_error_ != NULL) {
#line 183 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 183 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		g_clear_error (&_inner_error_);
#line 183 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		return;
#line 1771 "service.c"
	}
}


/**
            like:
            @id: the gwibber message id
            @account: the account id
           
            returns a bool
        */
gboolean gwibber_service_like (GwibberService* self, const gchar* id, const gchar* account) {
	gboolean result = FALSE;
	gchar* _tmp0_;
	gchar* mid;
	const gchar* _tmp1_;
	GError * _inner_error_ = NULL;
#line 197 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 197 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
	g_return_val_if_fail (id != NULL, FALSE);
#line 197 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
	g_return_val_if_fail (account != NULL, FALSE);
#line 199 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
	_tmp0_ = g_strdup ("");
#line 199 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
	mid = _tmp0_;
#line 200 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
	_tmp1_ = id;
#line 200 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
	if (_tmp1_ != NULL) {
#line 1803 "service.c"
		{
			GwibberMessages* _tmp2_;
			const gchar* _tmp3_;
			gchar* _tmp4_ = NULL;
			gchar* msg;
			const gchar* _tmp5_;
			gint _tmp6_;
			gint _tmp7_;
			JsonParser* _tmp8_;
			JsonParser* parser;
			JsonParser* _tmp9_;
			const gchar* _tmp10_;
			JsonParser* _tmp11_;
			JsonNode* _tmp12_ = NULL;
			JsonObject* _tmp13_ = NULL;
			const gchar* _tmp14_ = NULL;
			gchar* _tmp15_;
			const gchar* _tmp16_;
			gint _tmp17_;
			gint _tmp18_;
#line 203 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
			_tmp2_ = self->priv->messages;
#line 203 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
			_tmp3_ = id;
#line 203 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
			_tmp4_ = gwibber_messages_get_message (_tmp2_, _tmp3_);
#line 203 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
			msg = _tmp4_;
#line 204 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
			_tmp5_ = msg;
#line 204 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
			_tmp6_ = strlen (_tmp5_);
#line 204 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
			_tmp7_ = _tmp6_;
#line 204 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
			if (_tmp7_ < 1) {
#line 205 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
				result = FALSE;
#line 205 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
				_g_free0 (msg);
#line 205 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
				_g_free0 (mid);
#line 205 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
				return result;
#line 1848 "service.c"
			}
#line 207 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
			_tmp8_ = json_parser_new ();
#line 207 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
			parser = _tmp8_;
#line 208 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
			_tmp9_ = parser;
#line 208 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
			_tmp10_ = msg;
#line 208 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
			json_parser_load_from_data (_tmp9_, _tmp10_, (gssize) (-1), &_inner_error_);
#line 208 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
			if (_inner_error_ != NULL) {
#line 208 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
				_g_object_unref0 (parser);
#line 208 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
				_g_free0 (msg);
#line 1866 "service.c"
				goto __catch15_g_error;
			}
#line 210 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
			_tmp11_ = parser;
#line 210 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
			_tmp12_ = json_parser_get_root (_tmp11_);
#line 210 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
			_tmp13_ = json_node_get_object (_tmp12_);
#line 210 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
			_tmp14_ = json_object_get_string_member (_tmp13_, "mid");
#line 210 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
			_tmp15_ = g_strdup (_tmp14_);
#line 210 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
			_g_free0 (mid);
#line 210 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
			mid = _tmp15_;
#line 211 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
			_tmp16_ = mid;
#line 211 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
			_tmp17_ = strlen (_tmp16_);
#line 211 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
			_tmp18_ = _tmp17_;
#line 211 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
			if (_tmp18_ < 1) {
#line 212 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
				result = FALSE;
#line 212 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
				_g_object_unref0 (parser);
#line 212 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
				_g_free0 (msg);
#line 212 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
				_g_free0 (mid);
#line 212 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
				return result;
#line 1901 "service.c"
			}
			{
				ServiceInterface* _tmp19_;
				const gchar* _tmp20_;
				const gchar* _tmp21_;
#line 214 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
				_tmp19_ = self->priv->service;
#line 214 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
				_tmp20_ = mid;
#line 214 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
				_tmp21_ = account;
#line 214 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
				service_interface_Like (_tmp19_, _tmp20_, _tmp21_, &_inner_error_);
#line 214 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
				if (_inner_error_ != NULL) {
#line 214 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
					if (_inner_error_->domain == G_IO_ERROR) {
#line 1919 "service.c"
						goto __catch16_g_io_error;
					}
#line 214 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
					_g_object_unref0 (parser);
#line 214 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
					_g_free0 (msg);
#line 214 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
					_g_free0 (mid);
#line 214 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
					g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 214 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
					g_clear_error (&_inner_error_);
#line 214 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
					return FALSE;
#line 1934 "service.c"
				}
#line 215 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
				result = TRUE;
#line 215 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
				_g_object_unref0 (parser);
#line 215 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
				_g_free0 (msg);
#line 215 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
				_g_free0 (mid);
#line 215 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
				return result;
#line 1946 "service.c"
			}
			goto __finally16;
			__catch16_g_io_error:
			{
				GError* e = NULL;
				GError* _tmp22_;
				const gchar* _tmp23_;
#line 213 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
				e = _inner_error_;
#line 213 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
				_inner_error_ = NULL;
#line 217 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
				_tmp22_ = e;
#line 217 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
				_tmp23_ = _tmp22_->message;
#line 217 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
				g_warning ("service.vala:217: %s", _tmp23_);
#line 218 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
				result = FALSE;
#line 218 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
				_g_error_free0 (e);
#line 218 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
				_g_object_unref0 (parser);
#line 218 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
				_g_free0 (msg);
#line 218 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
				_g_free0 (mid);
#line 218 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
				return result;
#line 1976 "service.c"
			}
			__finally16:
#line 213 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
			_g_object_unref0 (parser);
#line 213 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
			_g_free0 (msg);
#line 1983 "service.c"
			goto __catch15_g_error;
		}
		goto __finally15;
		__catch15_g_error:
		{
			GError* e = NULL;
			GError* _tmp24_;
			const gchar* _tmp25_;
#line 202 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
			e = _inner_error_;
#line 202 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
			_inner_error_ = NULL;
#line 221 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
			_tmp24_ = e;
#line 221 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
			_tmp25_ = _tmp24_->message;
#line 221 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
			g_warning ("service.vala:221: %s", _tmp25_);
#line 222 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
			result = FALSE;
#line 222 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
			_g_error_free0 (e);
#line 222 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
			_g_free0 (mid);
#line 222 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
			return result;
#line 2010 "service.c"
		}
		__finally15:
#line 202 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		_g_free0 (mid);
#line 202 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 202 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		g_clear_error (&_inner_error_);
#line 202 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		return FALSE;
#line 2021 "service.c"
	}
#line 225 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
	result = FALSE;
#line 225 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
	_g_free0 (mid);
#line 225 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
	return result;
#line 2029 "service.c"
}


/**
            unlike:
            @id: the gwibber message id
            @account: the account id
           
            returns a bool
        */
gboolean gwibber_service_unlike (GwibberService* self, const gchar* id, const gchar* account) {
	gboolean result = FALSE;
	gchar* _tmp0_;
	gchar* mid;
	const gchar* _tmp1_;
	GError * _inner_error_ = NULL;
#line 235 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 235 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
	g_return_val_if_fail (id != NULL, FALSE);
#line 235 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
	g_return_val_if_fail (account != NULL, FALSE);
#line 237 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
	_tmp0_ = g_strdup ("");
#line 237 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
	mid = _tmp0_;
#line 238 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
	_tmp1_ = id;
#line 238 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
	if (_tmp1_ != NULL) {
#line 2060 "service.c"
		{
			GwibberMessages* _tmp2_;
			const gchar* _tmp3_;
			gchar* _tmp4_ = NULL;
			gchar* msg;
			const gchar* _tmp5_;
			gint _tmp6_;
			gint _tmp7_;
			JsonParser* _tmp8_;
			JsonParser* parser;
			JsonParser* _tmp9_;
			const gchar* _tmp10_;
			JsonParser* _tmp11_;
			JsonNode* _tmp12_ = NULL;
			JsonObject* _tmp13_ = NULL;
			const gchar* _tmp14_ = NULL;
			gchar* _tmp15_;
			const gchar* _tmp16_;
			gint _tmp17_;
			gint _tmp18_;
#line 241 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
			_tmp2_ = self->priv->messages;
#line 241 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
			_tmp3_ = id;
#line 241 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
			_tmp4_ = gwibber_messages_get_message (_tmp2_, _tmp3_);
#line 241 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
			msg = _tmp4_;
#line 242 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
			_tmp5_ = msg;
#line 242 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
			_tmp6_ = strlen (_tmp5_);
#line 242 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
			_tmp7_ = _tmp6_;
#line 242 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
			if (_tmp7_ < 1) {
#line 243 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
				result = FALSE;
#line 243 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
				_g_free0 (msg);
#line 243 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
				_g_free0 (mid);
#line 243 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
				return result;
#line 2105 "service.c"
			}
#line 245 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
			_tmp8_ = json_parser_new ();
#line 245 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
			parser = _tmp8_;
#line 246 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
			_tmp9_ = parser;
#line 246 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
			_tmp10_ = msg;
#line 246 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
			json_parser_load_from_data (_tmp9_, _tmp10_, (gssize) (-1), &_inner_error_);
#line 246 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
			if (_inner_error_ != NULL) {
#line 246 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
				_g_object_unref0 (parser);
#line 246 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
				_g_free0 (msg);
#line 2123 "service.c"
				goto __catch17_g_error;
			}
#line 248 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
			_tmp11_ = parser;
#line 248 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
			_tmp12_ = json_parser_get_root (_tmp11_);
#line 248 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
			_tmp13_ = json_node_get_object (_tmp12_);
#line 248 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
			_tmp14_ = json_object_get_string_member (_tmp13_, "mid");
#line 248 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
			_tmp15_ = g_strdup (_tmp14_);
#line 248 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
			_g_free0 (mid);
#line 248 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
			mid = _tmp15_;
#line 249 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
			_tmp16_ = mid;
#line 249 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
			_tmp17_ = strlen (_tmp16_);
#line 249 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
			_tmp18_ = _tmp17_;
#line 249 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
			if (_tmp18_ < 1) {
#line 250 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
				result = FALSE;
#line 250 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
				_g_object_unref0 (parser);
#line 250 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
				_g_free0 (msg);
#line 250 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
				_g_free0 (mid);
#line 250 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
				return result;
#line 2158 "service.c"
			}
			{
				ServiceInterface* _tmp19_;
				const gchar* _tmp20_;
				const gchar* _tmp21_;
#line 252 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
				_tmp19_ = self->priv->service;
#line 252 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
				_tmp20_ = mid;
#line 252 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
				_tmp21_ = account;
#line 252 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
				service_interface_UnLike (_tmp19_, _tmp20_, _tmp21_, &_inner_error_);
#line 252 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
				if (_inner_error_ != NULL) {
#line 252 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
					if (_inner_error_->domain == G_IO_ERROR) {
#line 2176 "service.c"
						goto __catch18_g_io_error;
					}
#line 252 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
					_g_object_unref0 (parser);
#line 252 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
					_g_free0 (msg);
#line 252 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
					_g_free0 (mid);
#line 252 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
					g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 252 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
					g_clear_error (&_inner_error_);
#line 252 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
					return FALSE;
#line 2191 "service.c"
				}
#line 253 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
				result = TRUE;
#line 253 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
				_g_object_unref0 (parser);
#line 253 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
				_g_free0 (msg);
#line 253 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
				_g_free0 (mid);
#line 253 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
				return result;
#line 2203 "service.c"
			}
			goto __finally18;
			__catch18_g_io_error:
			{
				GError* e = NULL;
				GError* _tmp22_;
				const gchar* _tmp23_;
#line 251 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
				e = _inner_error_;
#line 251 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
				_inner_error_ = NULL;
#line 255 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
				_tmp22_ = e;
#line 255 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
				_tmp23_ = _tmp22_->message;
#line 255 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
				g_warning ("service.vala:255: %s", _tmp23_);
#line 256 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
				result = FALSE;
#line 256 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
				_g_error_free0 (e);
#line 256 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
				_g_object_unref0 (parser);
#line 256 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
				_g_free0 (msg);
#line 256 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
				_g_free0 (mid);
#line 256 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
				return result;
#line 2233 "service.c"
			}
			__finally18:
#line 251 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
			_g_object_unref0 (parser);
#line 251 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
			_g_free0 (msg);
#line 2240 "service.c"
			goto __catch17_g_error;
		}
		goto __finally17;
		__catch17_g_error:
		{
			GError* e = NULL;
			GError* _tmp24_;
			const gchar* _tmp25_;
#line 240 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
			e = _inner_error_;
#line 240 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
			_inner_error_ = NULL;
#line 259 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
			_tmp24_ = e;
#line 259 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
			_tmp25_ = _tmp24_->message;
#line 259 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
			g_warning ("service.vala:259: %s", _tmp25_);
#line 260 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
			result = FALSE;
#line 260 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
			_g_error_free0 (e);
#line 260 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
			_g_free0 (mid);
#line 260 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
			return result;
#line 2267 "service.c"
		}
		__finally17:
#line 240 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		_g_free0 (mid);
#line 240 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 240 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		g_clear_error (&_inner_error_);
#line 240 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		return FALSE;
#line 2278 "service.c"
	}
#line 263 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
	result = FALSE;
#line 263 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
	_g_free0 (mid);
#line 263 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
	return result;
#line 2286 "service.c"
}


/**
            retweet:
            @id: the gwibber message id
            @account: the account id
           
            returns a bool
        */
gboolean gwibber_service_retweet (GwibberService* self, const gchar* id, const gchar* account) {
	gboolean result = FALSE;
	gchar* _tmp0_;
	gchar* mid;
	const gchar* _tmp1_;
	GError * _inner_error_ = NULL;
#line 276 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 276 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
	g_return_val_if_fail (id != NULL, FALSE);
#line 276 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
	g_return_val_if_fail (account != NULL, FALSE);
#line 278 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
	_tmp0_ = g_strdup ("");
#line 278 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
	mid = _tmp0_;
#line 279 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
	_tmp1_ = id;
#line 279 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
	if (_tmp1_ != NULL) {
#line 2317 "service.c"
		{
			GwibberMessages* _tmp2_;
			const gchar* _tmp3_;
			gchar* _tmp4_ = NULL;
			gchar* msg;
			const gchar* _tmp5_;
			gint _tmp6_;
			gint _tmp7_;
			JsonParser* _tmp8_;
			JsonParser* parser;
			JsonParser* _tmp9_;
			const gchar* _tmp10_;
			JsonParser* _tmp11_;
			JsonNode* _tmp12_ = NULL;
			JsonObject* _tmp13_ = NULL;
			const gchar* _tmp14_ = NULL;
			gchar* _tmp15_;
			const gchar* _tmp16_;
			gint _tmp17_;
			gint _tmp18_;
#line 282 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
			_tmp2_ = self->priv->messages;
#line 282 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
			_tmp3_ = id;
#line 282 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
			_tmp4_ = gwibber_messages_get_message (_tmp2_, _tmp3_);
#line 282 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
			msg = _tmp4_;
#line 283 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
			_tmp5_ = msg;
#line 283 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
			_tmp6_ = strlen (_tmp5_);
#line 283 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
			_tmp7_ = _tmp6_;
#line 283 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
			if (_tmp7_ < 1) {
#line 284 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
				result = FALSE;
#line 284 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
				_g_free0 (msg);
#line 284 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
				_g_free0 (mid);
#line 284 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
				return result;
#line 2362 "service.c"
			}
#line 286 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
			_tmp8_ = json_parser_new ();
#line 286 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
			parser = _tmp8_;
#line 287 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
			_tmp9_ = parser;
#line 287 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
			_tmp10_ = msg;
#line 287 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
			json_parser_load_from_data (_tmp9_, _tmp10_, (gssize) (-1), &_inner_error_);
#line 287 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
			if (_inner_error_ != NULL) {
#line 287 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
				_g_object_unref0 (parser);
#line 287 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
				_g_free0 (msg);
#line 2380 "service.c"
				goto __catch19_g_error;
			}
#line 289 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
			_tmp11_ = parser;
#line 289 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
			_tmp12_ = json_parser_get_root (_tmp11_);
#line 289 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
			_tmp13_ = json_node_get_object (_tmp12_);
#line 289 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
			_tmp14_ = json_object_get_string_member (_tmp13_, "mid");
#line 289 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
			_tmp15_ = g_strdup (_tmp14_);
#line 289 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
			_g_free0 (mid);
#line 289 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
			mid = _tmp15_;
#line 290 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
			_tmp16_ = mid;
#line 290 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
			_tmp17_ = strlen (_tmp16_);
#line 290 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
			_tmp18_ = _tmp17_;
#line 290 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
			if (_tmp18_ < 1) {
#line 291 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
				result = FALSE;
#line 291 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
				_g_object_unref0 (parser);
#line 291 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
				_g_free0 (msg);
#line 291 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
				_g_free0 (mid);
#line 291 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
				return result;
#line 2415 "service.c"
			}
			{
				ServiceInterface* _tmp19_;
				const gchar* _tmp20_;
				const gchar* _tmp21_;
#line 293 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
				_tmp19_ = self->priv->service;
#line 293 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
				_tmp20_ = mid;
#line 293 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
				_tmp21_ = account;
#line 293 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
				service_interface_Retweet (_tmp19_, _tmp20_, _tmp21_, &_inner_error_);
#line 293 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
				if (_inner_error_ != NULL) {
#line 293 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
					if (_inner_error_->domain == G_IO_ERROR) {
#line 2433 "service.c"
						goto __catch20_g_io_error;
					}
#line 293 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
					_g_object_unref0 (parser);
#line 293 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
					_g_free0 (msg);
#line 293 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
					_g_free0 (mid);
#line 293 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
					g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 293 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
					g_clear_error (&_inner_error_);
#line 293 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
					return FALSE;
#line 2448 "service.c"
				}
#line 294 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
				result = TRUE;
#line 294 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
				_g_object_unref0 (parser);
#line 294 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
				_g_free0 (msg);
#line 294 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
				_g_free0 (mid);
#line 294 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
				return result;
#line 2460 "service.c"
			}
			goto __finally20;
			__catch20_g_io_error:
			{
				GError* e = NULL;
				GError* _tmp22_;
				const gchar* _tmp23_;
#line 292 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
				e = _inner_error_;
#line 292 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
				_inner_error_ = NULL;
#line 296 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
				_tmp22_ = e;
#line 296 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
				_tmp23_ = _tmp22_->message;
#line 296 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
				g_warning ("service.vala:296: %s", _tmp23_);
#line 297 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
				result = FALSE;
#line 297 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
				_g_error_free0 (e);
#line 297 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
				_g_object_unref0 (parser);
#line 297 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
				_g_free0 (msg);
#line 297 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
				_g_free0 (mid);
#line 297 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
				return result;
#line 2490 "service.c"
			}
			__finally20:
#line 292 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
			_g_object_unref0 (parser);
#line 292 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
			_g_free0 (msg);
#line 2497 "service.c"
			goto __catch19_g_error;
		}
		goto __finally19;
		__catch19_g_error:
		{
			GError* e = NULL;
			GError* _tmp24_;
			const gchar* _tmp25_;
#line 281 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
			e = _inner_error_;
#line 281 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
			_inner_error_ = NULL;
#line 300 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
			_tmp24_ = e;
#line 300 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
			_tmp25_ = _tmp24_->message;
#line 300 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
			g_warning ("service.vala:300: %s", _tmp25_);
#line 301 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
			result = FALSE;
#line 301 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
			_g_error_free0 (e);
#line 301 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
			_g_free0 (mid);
#line 301 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
			return result;
#line 2524 "service.c"
		}
		__finally19:
#line 281 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		_g_free0 (mid);
#line 281 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 281 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		g_clear_error (&_inner_error_);
#line 281 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		return FALSE;
#line 2535 "service.c"
	}
#line 304 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
	result = FALSE;
#line 304 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
	_g_free0 (mid);
#line 304 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
	return result;
#line 2543 "service.c"
}


/**
            send_message:
            @message: The message to post to Gwibber
            @id: The gwibber message id or null
            @action: The action or null
            @account: The account to post from  or null

            Posts a message
        */
static void _vala_JsonNode_free (JsonNode* self) {
#line 336 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
	g_boxed_free (json_node_get_type (), self);
#line 2559 "service.c"
}


static JsonArray* _vala_JsonArray_copy (JsonArray* self) {
#line 349 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
	return g_boxed_copy (json_array_get_type (), self);
#line 2566 "service.c"
}


static gpointer __vala_JsonArray_copy0 (gpointer self) {
#line 349 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
	return self ? _vala_JsonArray_copy (self) : NULL;
#line 2573 "service.c"
}


static void _vala_JsonArray_free (JsonArray* self) {
#line 344 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
	g_boxed_free (json_array_get_type (), self);
#line 2580 "service.c"
}


gboolean gwibber_service_send_message (GwibberService* self, const gchar* message, const gchar* id, const gchar* action, gchar** accounts, int accounts_length1) {
	gboolean result = FALSE;
	gsize length = 0UL;
	gchar* json = NULL;
	gboolean _tmp0_ = FALSE;
	const gchar* _tmp1_;
	gboolean _tmp3_;
	GError * _inner_error_ = NULL;
#line 317 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 322 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
	_tmp1_ = id;
#line 322 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
	if (_tmp1_ != NULL) {
#line 2598 "service.c"
		const gchar* _tmp2_;
#line 322 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		_tmp2_ = action;
#line 322 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		_tmp0_ = _tmp2_ != NULL;
#line 2604 "service.c"
	} else {
#line 322 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		_tmp0_ = FALSE;
#line 2608 "service.c"
	}
#line 322 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
	_tmp3_ = _tmp0_;
#line 322 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
	if (_tmp3_) {
#line 2614 "service.c"
		{
			GwibberMessages* _tmp4_;
			const gchar* _tmp5_;
			gchar* _tmp6_ = NULL;
			gchar* msg;
			const gchar* _tmp7_;
			gint _tmp8_;
			gint _tmp9_;
			JsonGenerator* _tmp10_;
			JsonGenerator* msg_gen;
			JsonNode* _tmp11_;
			JsonNode* root;
			JsonObject* _tmp12_;
			JsonObject* object;
			JsonNode* _tmp13_;
			JsonObject* _tmp14_;
			JsonGenerator* _tmp15_;
			JsonNode* _tmp16_;
			JsonParser* _tmp17_;
			JsonParser* parser;
			JsonParser* _tmp18_;
			const gchar* _tmp19_;
			JsonObject* _tmp20_;
			const gchar* _tmp21_;
			const gchar* _tmp22_;
			const gchar* _tmp28_;
			JsonObject* _tmp34_;
			const gchar* _tmp35_;
			gchar** _tmp36_;
			gint _tmp36__length1;
			JsonGenerator* _tmp45_;
			gsize _tmp46_ = 0UL;
			gchar* _tmp47_ = NULL;
			ServiceInterface* _tmp48_;
			const gchar* _tmp49_;
#line 325 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
			_tmp4_ = self->priv->messages;
#line 325 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
			_tmp5_ = id;
#line 325 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
			_tmp6_ = gwibber_messages_get_message (_tmp4_, _tmp5_);
#line 325 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
			msg = _tmp6_;
#line 326 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
			_tmp7_ = msg;
#line 326 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
			_tmp8_ = strlen (_tmp7_);
#line 326 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
			_tmp9_ = _tmp8_;
#line 326 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
			if (_tmp9_ < 1) {
#line 327 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
				result = FALSE;
#line 327 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
				_g_free0 (msg);
#line 327 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
				_g_free0 (json);
#line 327 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
				return result;
#line 2674 "service.c"
			}
#line 329 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
			_tmp10_ = json_generator_new ();
#line 329 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
			msg_gen = _tmp10_;
#line 330 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
			_tmp11_ = json_node_new (JSON_NODE_OBJECT);
#line 330 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
			root = _tmp11_;
#line 331 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
			_tmp12_ = json_object_new ();
#line 331 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
			object = _tmp12_;
#line 332 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
			_tmp13_ = root;
#line 332 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
			_tmp14_ = object;
#line 332 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
			json_node_set_object (_tmp13_, _tmp14_);
#line 333 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
			_tmp15_ = msg_gen;
#line 333 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
			_tmp16_ = root;
#line 333 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
			json_generator_set_root (_tmp15_, _tmp16_);
#line 335 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
			_tmp17_ = json_parser_new ();
#line 335 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
			parser = _tmp17_;
#line 336 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
			_tmp18_ = parser;
#line 336 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
			_tmp19_ = msg;
#line 336 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
			json_parser_load_from_data (_tmp18_, _tmp19_, (gssize) (-1), &_inner_error_);
#line 336 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
			if (_inner_error_ != NULL) {
#line 336 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
				_g_object_unref0 (parser);
#line 336 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
				__vala_JsonObject_free0 (object);
#line 336 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
				__vala_JsonNode_free0 (root);
#line 336 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
				_g_object_unref0 (msg_gen);
#line 336 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
				_g_free0 (msg);
#line 2722 "service.c"
				goto __catch21_g_error;
			}
#line 338 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
			_tmp20_ = object;
#line 338 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
			_tmp21_ = message;
#line 338 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
			json_object_set_string_member (_tmp20_, "message", _tmp21_);
#line 339 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
			_tmp22_ = action;
#line 339 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
			if (g_strcmp0 (_tmp22_, "reply") == 0) {
#line 2735 "service.c"
				JsonObject* _tmp23_;
				JsonParser* _tmp24_;
				JsonNode* _tmp25_ = NULL;
				JsonObject* _tmp26_ = NULL;
				JsonObject* _tmp27_;
#line 340 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
				_tmp23_ = object;
#line 340 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
				_tmp24_ = parser;
#line 340 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
				_tmp25_ = json_parser_get_root (_tmp24_);
#line 340 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
				_tmp26_ = json_node_get_object (_tmp25_);
#line 340 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
				_tmp27_ = __vala_JsonObject_copy0 (_tmp26_);
#line 340 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
				json_object_set_object_member (_tmp23_, "target", _tmp27_);
#line 2753 "service.c"
			}
#line 341 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
			_tmp28_ = action;
#line 341 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
			if (g_strcmp0 (_tmp28_, "private") == 0) {
#line 2759 "service.c"
				JsonObject* _tmp29_;
				JsonParser* _tmp30_;
				JsonNode* _tmp31_ = NULL;
				JsonObject* _tmp32_ = NULL;
				JsonObject* _tmp33_;
#line 342 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
				_tmp29_ = object;
#line 342 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
				_tmp30_ = parser;
#line 342 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
				_tmp31_ = json_parser_get_root (_tmp30_);
#line 342 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
				_tmp32_ = json_node_get_object (_tmp31_);
#line 342 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
				_tmp33_ = __vala_JsonObject_copy0 (_tmp32_);
#line 342 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
				json_object_set_object_member (_tmp29_, "private", _tmp33_);
#line 2777 "service.c"
			}
#line 343 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
			_tmp34_ = object;
#line 343 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
			_tmp35_ = action;
#line 343 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
			json_object_set_string_member (_tmp34_, "action", _tmp35_);
#line 344 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
			_tmp36_ = accounts;
#line 344 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
			_tmp36__length1 = accounts_length1;
#line 344 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
			if (_tmp36__length1 > 0) {
#line 2791 "service.c"
				JsonArray* _tmp37_;
				JsonArray* acct_array;
				gchar** _tmp38_;
				gint _tmp38__length1;
				JsonObject* _tmp42_;
				JsonArray* _tmp43_;
				JsonArray* _tmp44_;
#line 346 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
				_tmp37_ = json_array_new ();
#line 346 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
				acct_array = _tmp37_;
#line 347 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
				_tmp38_ = accounts;
#line 347 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
				_tmp38__length1 = accounts_length1;
#line 2807 "service.c"
				{
					gchar** a_collection = NULL;
					gint a_collection_length1 = 0;
					gint _a_collection_size_ = 0;
					gint a_it = 0;
#line 347 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
					a_collection = _tmp38_;
#line 347 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
					a_collection_length1 = _tmp38__length1;
#line 347 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
					for (a_it = 0; a_it < _tmp38__length1; a_it = a_it + 1) {
#line 2819 "service.c"
						gchar* _tmp39_;
						gchar* a = NULL;
#line 347 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
						_tmp39_ = g_strdup (a_collection[a_it]);
#line 347 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
						a = _tmp39_;
#line 2826 "service.c"
						{
							JsonArray* _tmp40_;
							const gchar* _tmp41_;
#line 348 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
							_tmp40_ = acct_array;
#line 348 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
							_tmp41_ = a;
#line 348 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
							json_array_add_string_element (_tmp40_, _tmp41_);
#line 347 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
							_g_free0 (a);
#line 2838 "service.c"
						}
					}
				}
#line 349 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
				_tmp42_ = object;
#line 349 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
				_tmp43_ = acct_array;
#line 349 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
				_tmp44_ = __vala_JsonArray_copy0 (_tmp43_);
#line 349 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
				json_object_set_array_member (_tmp42_, "accounts", _tmp44_);
#line 344 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
				__vala_JsonArray_free0 (acct_array);
#line 2852 "service.c"
			}
#line 351 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
			_tmp45_ = msg_gen;
#line 351 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
			_tmp47_ = json_generator_to_data (_tmp45_, &_tmp46_);
#line 351 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
			length = _tmp46_;
#line 351 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
			_g_free0 (json);
#line 351 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
			json = _tmp47_;
#line 353 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
			_tmp48_ = self->priv->service;
#line 353 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
			_tmp49_ = json;
#line 353 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
			service_interface_Send (_tmp48_, (const gchar*) _tmp49_, &_inner_error_);
#line 353 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
			if (_inner_error_ != NULL) {
#line 353 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
				_g_object_unref0 (parser);
#line 353 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
				__vala_JsonObject_free0 (object);
#line 353 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
				__vala_JsonNode_free0 (root);
#line 353 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
				_g_object_unref0 (msg_gen);
#line 353 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
				_g_free0 (msg);
#line 2882 "service.c"
				goto __catch21_g_error;
			}
#line 354 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
			result = TRUE;
#line 354 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
			_g_object_unref0 (parser);
#line 354 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
			__vala_JsonObject_free0 (object);
#line 354 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
			__vala_JsonNode_free0 (root);
#line 354 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
			_g_object_unref0 (msg_gen);
#line 354 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
			_g_free0 (msg);
#line 354 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
			_g_free0 (json);
#line 354 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
			return result;
#line 2901 "service.c"
		}
		goto __finally21;
		__catch21_g_error:
		{
			GError* e = NULL;
			GError* _tmp50_;
			const gchar* _tmp51_;
#line 324 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
			e = _inner_error_;
#line 324 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
			_inner_error_ = NULL;
#line 356 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
			_tmp50_ = e;
#line 356 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
			_tmp51_ = _tmp50_->message;
#line 356 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
			g_warning ("service.vala:356: %s", _tmp51_);
#line 357 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
			result = FALSE;
#line 357 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
			_g_error_free0 (e);
#line 357 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
			_g_free0 (json);
#line 357 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
			return result;
#line 2927 "service.c"
		}
		__finally21:
#line 324 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		_g_free0 (json);
#line 324 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 324 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		g_clear_error (&_inner_error_);
#line 324 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		return FALSE;
#line 2938 "service.c"
	} else {
		{
			ServiceInterface* _tmp52_;
			const gchar* _tmp53_;
#line 362 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
			_tmp52_ = self->priv->service;
#line 362 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
			_tmp53_ = message;
#line 362 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
			service_interface_SendMessage (_tmp52_, _tmp53_, &_inner_error_);
#line 362 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
			if (_inner_error_ != NULL) {
#line 362 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
				if (_inner_error_->domain == G_IO_ERROR) {
#line 2953 "service.c"
					goto __catch22_g_io_error;
				}
#line 362 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
				_g_free0 (json);
#line 362 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 362 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
				g_clear_error (&_inner_error_);
#line 362 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
				return FALSE;
#line 2964 "service.c"
			}
#line 363 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
			result = TRUE;
#line 363 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
			_g_free0 (json);
#line 363 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
			return result;
#line 2972 "service.c"
		}
		goto __finally22;
		__catch22_g_io_error:
		{
			GError* e = NULL;
			GError* _tmp54_;
			const gchar* _tmp55_;
#line 361 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
			e = _inner_error_;
#line 361 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
			_inner_error_ = NULL;
#line 365 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
			_tmp54_ = e;
#line 365 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
			_tmp55_ = _tmp54_->message;
#line 365 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
			g_warning ("service.vala:365: %s", _tmp55_);
#line 366 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
			result = FALSE;
#line 366 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
			_g_error_free0 (e);
#line 366 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
			_g_free0 (json);
#line 366 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
			return result;
#line 2998 "service.c"
		}
		__finally22:
#line 361 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		_g_free0 (json);
#line 361 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 361 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		g_clear_error (&_inner_error_);
#line 361 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		return FALSE;
#line 3009 "service.c"
	}
#line 317 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
	_g_free0 (json);
#line 3013 "service.c"
}


static void _g_hash_table_remove_all_gdestroy_notify (void* data) {
#line 374 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
	g_hash_table_remove_all (data);
#line 3020 "service.c"
}


static void _g_free0_ (gpointer var) {
#line 398 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
	var = (g_free (var), NULL);
#line 3027 "service.c"
}


static void _g_list_free__g_free0_ (GList* self) {
#line 398 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
	g_list_foreach (self, (GFunc) _g_free0_, NULL);
#line 398 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
	g_list_free (self);
#line 3036 "service.c"
}


static gpointer _g_hash_table_ref0 (gpointer self) {
#line 401 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
	return self ? g_hash_table_ref (self) : NULL;
#line 3043 "service.c"
}


GHashTable* gwibber_service_services (GwibberService* self) {
	GHashTable* result = NULL;
	GHashFunc _tmp0_;
	GEqualFunc _tmp1_;
	GDestroyNotify _tmp2_;
	GHashTable* _tmp3_;
	GError * _inner_error_ = NULL;
#line 372 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 374 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
	_tmp0_ = g_str_hash;
#line 374 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
	_tmp1_ = g_str_equal;
#line 374 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
	_tmp2_ = g_free;
#line 374 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
	_tmp3_ = g_hash_table_new_full (_tmp0_, _tmp1_, _tmp2_, _g_hash_table_remove_all_gdestroy_notify);
#line 374 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
	_g_hash_table_unref0 (self->priv->services_table);
#line 374 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
	self->priv->services_table = _tmp3_;
#line 3068 "service.c"
	{
		ServiceInterface* _tmp4_;
		gchar* _tmp5_ = NULL;
		gchar* services;
		JsonParser* _tmp6_;
		JsonParser* parser;
		JsonParser* _tmp11_;
		JsonNode* _tmp12_ = NULL;
		JsonObject* _tmp13_ = NULL;
		JsonObject* _tmp14_;
		JsonObject* root_object;
		JsonObject* _tmp15_;
		GList* _tmp16_ = NULL;
		GHashTable* _tmp60_;
		GHashTable* _tmp61_;
#line 376 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		_tmp4_ = self->priv->service;
#line 376 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		_tmp5_ = service_interface_GetServices (_tmp4_, &_inner_error_);
#line 376 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		services = _tmp5_;
#line 376 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		if (_inner_error_ != NULL) {
#line 3092 "service.c"
			goto __catch23_g_error;
		}
#line 377 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		_tmp6_ = json_parser_new ();
#line 377 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		parser = _tmp6_;
#line 3099 "service.c"
		{
			JsonParser* _tmp7_;
			const gchar* _tmp8_;
#line 379 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
			_tmp7_ = parser;
#line 379 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
			_tmp8_ = services;
#line 379 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
			json_parser_load_from_data (_tmp7_, _tmp8_, (gssize) (-1), &_inner_error_);
#line 379 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
			if (_inner_error_ != NULL) {
#line 3111 "service.c"
				goto __catch24_g_error;
			}
		}
		goto __finally24;
		__catch24_g_error:
		{
			GError* e = NULL;
			GError* _tmp9_;
			const gchar* _tmp10_;
#line 378 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
			e = _inner_error_;
#line 378 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
			_inner_error_ = NULL;
#line 381 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
			_tmp9_ = e;
#line 381 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
			_tmp10_ = _tmp9_->message;
#line 381 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
			g_warning ("service.vala:381: %s", _tmp10_);
#line 382 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
			result = NULL;
#line 382 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
			_g_error_free0 (e);
#line 382 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
			_g_object_unref0 (parser);
#line 382 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
			_g_free0 (services);
#line 382 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
			return result;
#line 3141 "service.c"
		}
		__finally24:
#line 378 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		if (_inner_error_ != NULL) {
#line 378 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
			_g_object_unref0 (parser);
#line 378 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
			_g_free0 (services);
#line 3150 "service.c"
			goto __catch23_g_error;
		}
#line 384 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		_tmp11_ = parser;
#line 384 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		_tmp12_ = json_parser_get_root (_tmp11_);
#line 384 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		_tmp13_ = json_node_get_object (_tmp12_);
#line 384 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		_tmp14_ = __vala_JsonObject_copy0 (_tmp13_);
#line 384 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		root_object = _tmp14_;
#line 385 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		_tmp15_ = root_object;
#line 385 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		_tmp16_ = json_object_get_members (_tmp15_);
#line 3167 "service.c"
		{
			GList* service_collection = NULL;
			GList* service_it = NULL;
#line 385 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
			service_collection = _tmp16_;
#line 385 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
			for (service_it = service_collection; service_it != NULL; service_it = service_it->next) {
#line 3175 "service.c"
				const gchar* service = NULL;
#line 385 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
				service = (const gchar*) service_it->data;
#line 3179 "service.c"
				{
					GHashFunc _tmp17_;
					GEqualFunc _tmp18_;
					GDestroyNotify _tmp19_;
					GDestroyNotify _tmp20_;
					GHashTable* _tmp21_;
					JsonObject* _tmp22_;
					const gchar* _tmp23_;
					JsonNode* _tmp24_ = NULL;
					JsonObject* _tmp25_ = NULL;
					JsonObject* _tmp26_;
					JsonObject* services_object;
					JsonObject* _tmp27_;
					GList* _tmp28_ = NULL;
					GHashTable* _tmp55_;
					const gchar* _tmp56_;
					gchar* _tmp57_;
					GHashTable* _tmp58_;
					GHashTable* _tmp59_;
#line 386 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
					_tmp17_ = g_str_hash;
#line 386 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
					_tmp18_ = g_str_equal;
#line 386 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
					_tmp19_ = g_free;
#line 386 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
					_tmp20_ = g_free;
#line 386 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
					_tmp21_ = g_hash_table_new_full (_tmp17_, _tmp18_, _tmp19_, _tmp20_);
#line 386 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
					_g_hash_table_unref0 (self->priv->service_table);
#line 386 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
					self->priv->service_table = _tmp21_;
#line 387 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
					_tmp22_ = root_object;
#line 387 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
					_tmp23_ = service;
#line 387 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
					_tmp24_ = json_object_get_member (_tmp22_, _tmp23_);
#line 387 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
					_tmp25_ = json_node_get_object (_tmp24_);
#line 387 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
					_tmp26_ = __vala_JsonObject_copy0 (_tmp25_);
#line 387 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
					services_object = _tmp26_;
#line 388 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
					_tmp27_ = services_object;
#line 388 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
					_tmp28_ = json_object_get_members (_tmp27_);
#line 3229 "service.c"
					{
						GList* member_collection = NULL;
						GList* member_it = NULL;
#line 388 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
						member_collection = _tmp28_;
#line 388 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
						for (member_it = member_collection; member_it != NULL; member_it = member_it->next) {
#line 3237 "service.c"
							const gchar* member = NULL;
#line 388 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
							member = (const gchar*) member_it->data;
#line 3241 "service.c"
							{
								JsonObject* _tmp29_;
								const gchar* _tmp30_;
								JsonNode* _tmp31_ = NULL;
								const gchar* _tmp32_ = NULL;
#line 389 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
								_tmp29_ = services_object;
#line 389 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
								_tmp30_ = member;
#line 389 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
								_tmp31_ = json_object_get_member (_tmp29_, _tmp30_);
#line 389 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
								_tmp32_ = json_node_type_name (_tmp31_);
#line 389 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
								if (g_strcmp0 (_tmp32_, "JsonArray") == 0) {
#line 3257 "service.c"
									JsonObject* _tmp33_;
									const gchar* _tmp34_;
									JsonArray* _tmp35_ = NULL;
									JsonArray* _tmp36_;
									JsonArray* service_array;
									GList* service_attr_list;
									GHashTable* _tmp50_;
									const gchar* _tmp51_;
									gchar* _tmp52_;
									GList* _tmp53_;
									GList* _tmp54_ = NULL;
#line 390 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
									_tmp33_ = services_object;
#line 390 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
									_tmp34_ = member;
#line 390 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
									_tmp35_ = json_object_get_array_member (_tmp33_, _tmp34_);
#line 390 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
									_tmp36_ = __vala_JsonArray_copy0 (_tmp35_);
#line 390 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
									service_array = _tmp36_;
#line 391 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
									service_attr_list = NULL;
#line 3281 "service.c"
									{
										gint i;
#line 392 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
										i = 0;
#line 3286 "service.c"
										{
											gboolean _tmp37_;
#line 392 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
											_tmp37_ = TRUE;
#line 392 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
											while (TRUE) {
#line 3293 "service.c"
												gboolean _tmp38_;
												gint _tmp40_;
												JsonArray* _tmp41_;
												guint _tmp42_ = 0U;
												JsonArray* _tmp43_;
												gint _tmp44_;
												JsonNode* _tmp45_ = NULL;
												const gchar* _tmp46_ = NULL;
												gchar* _tmp47_;
												gchar* f;
												const gchar* _tmp48_;
												gchar* _tmp49_;
#line 392 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
												_tmp38_ = _tmp37_;
#line 392 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
												if (!_tmp38_) {
#line 3310 "service.c"
													gint _tmp39_;
#line 392 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
													_tmp39_ = i;
#line 392 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
													i = _tmp39_ + 1;
#line 3316 "service.c"
												}
#line 392 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
												_tmp37_ = FALSE;
#line 392 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
												_tmp40_ = i;
#line 392 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
												_tmp41_ = service_array;
#line 392 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
												_tmp42_ = json_array_get_length (_tmp41_);
#line 392 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
												if (!(((guint) _tmp40_) < _tmp42_)) {
#line 392 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
													break;
#line 3330 "service.c"
												}
#line 393 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
												_tmp43_ = service_array;
#line 393 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
												_tmp44_ = i;
#line 393 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
												_tmp45_ = json_array_get_element (_tmp43_, (guint) _tmp44_);
#line 393 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
												_tmp46_ = json_node_get_string (_tmp45_);
#line 393 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
												_tmp47_ = g_strdup (_tmp46_);
#line 393 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
												f = _tmp47_;
#line 394 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
												_tmp48_ = f;
#line 394 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
												_tmp49_ = g_strdup (_tmp48_);
#line 394 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
												service_attr_list = g_list_append (service_attr_list, _tmp49_);
#line 392 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
												_g_free0 (f);
#line 3352 "service.c"
											}
										}
									}
#line 397 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
									_tmp50_ = self->priv->service_table;
#line 397 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
									_tmp51_ = member;
#line 397 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
									_tmp52_ = g_strdup (_tmp51_);
#line 397 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
									_tmp53_ = service_attr_list;
#line 397 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
									_tmp54_ = g_list_copy (_tmp53_);
#line 397 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
									g_hash_table_insert (_tmp50_, _tmp52_, _tmp54_);
#line 398 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
									__g_list_free__g_free0_0 (service_attr_list);
#line 398 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
									__vala_JsonArray_free0 (service_array);
#line 398 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
									continue;
#line 3374 "service.c"
								}
							}
						}
#line 388 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
						_g_list_free0 (member_collection);
#line 3380 "service.c"
					}
#line 401 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
					_tmp55_ = self->priv->services_table;
#line 401 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
					_tmp56_ = service;
#line 401 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
					_tmp57_ = g_strdup (_tmp56_);
#line 401 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
					_tmp58_ = self->priv->service_table;
#line 401 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
					_tmp59_ = _g_hash_table_ref0 (_tmp58_);
#line 401 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
					g_hash_table_insert (_tmp55_, _tmp57_, _tmp59_);
#line 385 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
					__vala_JsonObject_free0 (services_object);
#line 3396 "service.c"
				}
			}
#line 385 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
			_g_list_free0 (service_collection);
#line 3401 "service.c"
		}
#line 403 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		_tmp60_ = self->priv->services_table;
#line 403 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		_tmp61_ = _g_hash_table_ref0 (_tmp60_);
#line 403 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		result = _tmp61_;
#line 403 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		__vala_JsonObject_free0 (root_object);
#line 403 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		_g_object_unref0 (parser);
#line 403 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		_g_free0 (services);
#line 403 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		return result;
#line 3417 "service.c"
	}
	goto __finally23;
	__catch23_g_error:
	{
		GError* e = NULL;
		GError* _tmp62_;
		const gchar* _tmp63_;
#line 375 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		e = _inner_error_;
#line 375 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		_inner_error_ = NULL;
#line 405 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		_tmp62_ = e;
#line 405 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		_tmp63_ = _tmp62_->message;
#line 405 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		g_warning ("service.vala:405: %s", _tmp63_);
#line 406 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		result = NULL;
#line 406 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		_g_error_free0 (e);
#line 406 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		return result;
#line 3441 "service.c"
	}
	__finally23:
#line 375 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 375 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
	g_clear_error (&_inner_error_);
#line 375 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
	return NULL;
#line 3450 "service.c"
}


static void _vala_GValue_free (GValue* self) {
#line 429 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
	g_value_unset (self);
#line 429 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
	g_free (self);
#line 3459 "service.c"
}


static GValue* _g_value_dup (GValue* self) {
#line 433 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
	return g_boxed_copy (G_TYPE_VALUE, self);
#line 3466 "service.c"
}


static gpointer __g_value_dup0 (gpointer self) {
#line 433 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
	return self ? _g_value_dup (self) : NULL;
#line 3473 "service.c"
}


GHashTable* gwibber_service_features (GwibberService* self) {
	GHashTable* result = NULL;
	GHashFunc _tmp0_;
	GEqualFunc _tmp1_;
	GDestroyNotify _tmp2_;
	GHashTable* _tmp3_;
	GError * _inner_error_ = NULL;
#line 410 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 412 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
	_tmp0_ = g_str_hash;
#line 412 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
	_tmp1_ = g_str_equal;
#line 412 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
	_tmp2_ = g_free;
#line 412 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
	_tmp3_ = g_hash_table_new_full (_tmp0_, _tmp1_, _tmp2_, _g_hash_table_remove_all_gdestroy_notify);
#line 412 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
	_g_hash_table_unref0 (self->priv->features_table);
#line 412 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
	self->priv->features_table = _tmp3_;
#line 3498 "service.c"
	{
		ServiceInterface* _tmp4_;
		gchar* _tmp5_ = NULL;
		gchar* features;
		JsonParser* _tmp6_;
		JsonParser* parser;
		JsonParser* _tmp11_;
		JsonNode* _tmp12_ = NULL;
		JsonObject* _tmp13_ = NULL;
		JsonObject* _tmp14_;
		JsonObject* root_object;
		JsonObject* _tmp15_;
		GList* _tmp16_ = NULL;
		GHashTable* _tmp58_;
		GHashTable* _tmp59_;
#line 414 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		_tmp4_ = self->priv->service;
#line 414 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		_tmp5_ = service_interface_GetFeatures (_tmp4_, &_inner_error_);
#line 414 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		features = _tmp5_;
#line 414 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		if (_inner_error_ != NULL) {
#line 414 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
			if (_inner_error_->domain == G_IO_ERROR) {
#line 3524 "service.c"
				goto __catch25_g_io_error;
			}
#line 414 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 414 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
			g_clear_error (&_inner_error_);
#line 414 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
			return NULL;
#line 3533 "service.c"
		}
#line 415 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		_tmp6_ = json_parser_new ();
#line 415 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		parser = _tmp6_;
#line 3539 "service.c"
		{
			JsonParser* _tmp7_;
			const gchar* _tmp8_;
#line 417 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
			_tmp7_ = parser;
#line 417 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
			_tmp8_ = features;
#line 417 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
			json_parser_load_from_data (_tmp7_, _tmp8_, (gssize) (-1), &_inner_error_);
#line 417 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
			if (_inner_error_ != NULL) {
#line 3551 "service.c"
				goto __catch26_g_error;
			}
		}
		goto __finally26;
		__catch26_g_error:
		{
			GError* e = NULL;
			GError* _tmp9_;
			const gchar* _tmp10_;
#line 416 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
			e = _inner_error_;
#line 416 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
			_inner_error_ = NULL;
#line 419 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
			_tmp9_ = e;
#line 419 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
			_tmp10_ = _tmp9_->message;
#line 419 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
			g_warning ("service.vala:419: %s", _tmp10_);
#line 420 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
			result = NULL;
#line 420 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
			_g_error_free0 (e);
#line 420 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
			_g_object_unref0 (parser);
#line 420 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
			_g_free0 (features);
#line 420 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
			return result;
#line 3581 "service.c"
		}
		__finally26:
#line 416 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		if (_inner_error_ != NULL) {
#line 416 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
			_g_object_unref0 (parser);
#line 416 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
			_g_free0 (features);
#line 416 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
			if (_inner_error_->domain == G_IO_ERROR) {
#line 3592 "service.c"
				goto __catch25_g_io_error;
			}
#line 416 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
			_g_object_unref0 (parser);
#line 416 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
			_g_free0 (features);
#line 416 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 416 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
			g_clear_error (&_inner_error_);
#line 416 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
			return NULL;
#line 3605 "service.c"
		}
#line 422 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		_tmp11_ = parser;
#line 422 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		_tmp12_ = json_parser_get_root (_tmp11_);
#line 422 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		_tmp13_ = json_node_get_object (_tmp12_);
#line 422 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		_tmp14_ = __vala_JsonObject_copy0 (_tmp13_);
#line 422 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		root_object = _tmp14_;
#line 423 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		_tmp15_ = root_object;
#line 423 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		_tmp16_ = json_object_get_members (_tmp15_);
#line 3621 "service.c"
		{
			GList* feature_collection = NULL;
			GList* feature_it = NULL;
#line 423 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
			feature_collection = _tmp16_;
#line 423 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
			for (feature_it = feature_collection; feature_it != NULL; feature_it = feature_it->next) {
#line 3629 "service.c"
				const gchar* feature = NULL;
#line 423 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
				feature = (const gchar*) feature_it->data;
#line 3633 "service.c"
				{
					GHashFunc _tmp17_;
					GEqualFunc _tmp18_;
					GDestroyNotify _tmp19_;
					GDestroyNotify _tmp20_;
					GHashTable* _tmp21_;
					JsonObject* _tmp22_;
					const gchar* _tmp23_;
					JsonNode* _tmp24_ = NULL;
					JsonObject* _tmp25_ = NULL;
					JsonObject* _tmp26_;
					JsonObject* features_object;
					JsonObject* _tmp27_;
					GList* _tmp28_ = NULL;
					GHashTable* _tmp53_;
					const gchar* _tmp54_;
					gchar* _tmp55_;
					GHashTable* _tmp56_;
					GHashTable* _tmp57_;
#line 424 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
					_tmp17_ = g_str_hash;
#line 424 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
					_tmp18_ = g_str_equal;
#line 424 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
					_tmp19_ = g_free;
#line 424 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
					_tmp20_ = g_free;
#line 424 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
					_tmp21_ = g_hash_table_new_full (_tmp17_, _tmp18_, _tmp19_, _tmp20_);
#line 424 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
					_g_hash_table_unref0 (self->priv->feature_table);
#line 424 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
					self->priv->feature_table = _tmp21_;
#line 425 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
					_tmp22_ = root_object;
#line 425 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
					_tmp23_ = feature;
#line 425 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
					_tmp24_ = json_object_get_member (_tmp22_, _tmp23_);
#line 425 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
					_tmp25_ = json_node_get_object (_tmp24_);
#line 425 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
					_tmp26_ = __vala_JsonObject_copy0 (_tmp25_);
#line 425 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
					features_object = _tmp26_;
#line 426 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
					_tmp27_ = features_object;
#line 426 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
					_tmp28_ = json_object_get_members (_tmp27_);
#line 3683 "service.c"
					{
						GList* member_collection = NULL;
						GList* member_it = NULL;
#line 426 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
						member_collection = _tmp28_;
#line 426 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
						for (member_it = member_collection; member_it != NULL; member_it = member_it->next) {
#line 3691 "service.c"
							const gchar* member = NULL;
#line 426 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
							member = (const gchar*) member_it->data;
#line 3695 "service.c"
							{
								GValue* value;
								JsonObject* _tmp29_;
								const gchar* _tmp30_;
								JsonNode* _tmp31_ = NULL;
								gboolean _tmp32_ = FALSE;
								GHashTable* _tmp48_;
								const gchar* _tmp49_;
								gchar* _tmp50_;
								GValue* _tmp51_;
								GValue* _tmp52_;
#line 427 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
								value = NULL;
#line 428 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
								_tmp29_ = features_object;
#line 428 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
								_tmp30_ = member;
#line 428 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
								_tmp31_ = json_object_get_member (_tmp29_, _tmp30_);
#line 428 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
								_tmp32_ = json_node_is_null (_tmp31_);
#line 428 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
								if (_tmp32_) {
#line 429 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
									__vala_GValue_free0 (value);
#line 429 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
									continue;
#line 3723 "service.c"
								} else {
									JsonObject* _tmp33_;
									const gchar* _tmp34_;
									JsonNode* _tmp35_ = NULL;
									const gchar* _tmp36_ = NULL;
#line 430 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
									_tmp33_ = features_object;
#line 430 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
									_tmp34_ = member;
#line 430 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
									_tmp35_ = json_object_get_member (_tmp33_, _tmp34_);
#line 430 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
									_tmp36_ = json_node_type_name (_tmp35_);
#line 430 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
									if (g_strcmp0 (_tmp36_, "gboolean") == 0) {
#line 3739 "service.c"
										JsonObject* _tmp37_;
										const gchar* _tmp38_;
										JsonNode* _tmp39_ = NULL;
										gboolean _tmp40_ = FALSE;
										GValue* _tmp41_ = NULL;
#line 431 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
										_tmp37_ = features_object;
#line 431 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
										_tmp38_ = member;
#line 431 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
										_tmp39_ = json_object_get_member (_tmp37_, _tmp38_);
#line 431 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
										_tmp40_ = json_node_get_boolean (_tmp39_);
#line 431 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
										_tmp41_ = g_new0 (GValue, 1);
#line 431 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
										g_value_init (_tmp41_, G_TYPE_BOOLEAN);
#line 431 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
										g_value_set_boolean (_tmp41_, _tmp40_);
#line 431 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
										__vala_GValue_free0 (value);
#line 431 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
										value = _tmp41_;
#line 3763 "service.c"
									} else {
										JsonObject* _tmp42_;
										const gchar* _tmp43_;
										JsonNode* _tmp44_ = NULL;
										GValue _tmp45_ = {0};
										GValue _tmp46_;
										GValue* _tmp47_;
#line 433 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
										_tmp42_ = features_object;
#line 433 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
										_tmp43_ = member;
#line 433 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
										_tmp44_ = json_object_get_member (_tmp42_, _tmp43_);
#line 433 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
										json_node_get_value (_tmp44_, &_tmp45_);
#line 433 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
										_tmp46_ = _tmp45_;
#line 433 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
										_tmp47_ = __g_value_dup0 (&_tmp46_);
#line 433 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
										__vala_GValue_free0 (value);
#line 433 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
										value = _tmp47_;
#line 433 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
										G_IS_VALUE (&_tmp46_) ? (g_value_unset (&_tmp46_), NULL) : NULL;
#line 3789 "service.c"
									}
								}
#line 435 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
								_tmp48_ = self->priv->feature_table;
#line 435 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
								_tmp49_ = member;
#line 435 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
								_tmp50_ = g_strdup (_tmp49_);
#line 435 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
								_tmp51_ = value;
#line 435 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
								_tmp52_ = __g_value_dup0 (_tmp51_);
#line 435 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
								g_hash_table_insert (_tmp48_, _tmp50_, _tmp52_);
#line 426 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
								__vala_GValue_free0 (value);
#line 3806 "service.c"
							}
						}
#line 426 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
						_g_list_free0 (member_collection);
#line 3811 "service.c"
					}
#line 437 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
					_tmp53_ = self->priv->features_table;
#line 437 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
					_tmp54_ = feature;
#line 437 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
					_tmp55_ = g_strdup (_tmp54_);
#line 437 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
					_tmp56_ = self->priv->feature_table;
#line 437 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
					_tmp57_ = _g_hash_table_ref0 (_tmp56_);
#line 437 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
					g_hash_table_insert (_tmp53_, _tmp55_, _tmp57_);
#line 423 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
					__vala_JsonObject_free0 (features_object);
#line 3827 "service.c"
				}
			}
#line 423 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
			_g_list_free0 (feature_collection);
#line 3832 "service.c"
		}
#line 439 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		_tmp58_ = self->priv->features_table;
#line 439 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		_tmp59_ = _g_hash_table_ref0 (_tmp58_);
#line 439 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		result = _tmp59_;
#line 439 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		__vala_JsonObject_free0 (root_object);
#line 439 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		_g_object_unref0 (parser);
#line 439 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		_g_free0 (features);
#line 439 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		return result;
#line 3848 "service.c"
	}
	goto __finally25;
	__catch25_g_io_error:
	{
		GError* e = NULL;
		GError* _tmp60_;
		const gchar* _tmp61_;
#line 413 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		e = _inner_error_;
#line 413 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		_inner_error_ = NULL;
#line 441 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		_tmp60_ = e;
#line 441 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		_tmp61_ = _tmp60_->message;
#line 441 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		g_warning ("service.vala:441: %s", _tmp61_);
#line 442 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		result = NULL;
#line 442 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		_g_error_free0 (e);
#line 442 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		return result;
#line 3872 "service.c"
	}
	__finally25:
#line 413 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 413 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
	g_clear_error (&_inner_error_);
#line 413 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
	return NULL;
#line 3881 "service.c"
}


/**
            version:

            Return value: the version of the Gwibber service that is running.
        */
gchar* gwibber_service_version (GwibberService* self) {
	gchar* result = NULL;
	gchar* _tmp5_;
	GError * _inner_error_ = NULL;
#line 452 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 3896 "service.c"
	{
		ServiceInterface* _tmp0_;
		gchar* _tmp1_ = NULL;
		gchar* _tmp2_;
#line 455 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		_tmp0_ = self->priv->service;
#line 455 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		_tmp1_ = service_interface_GetVersion (_tmp0_, &_inner_error_);
#line 455 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		_tmp2_ = _tmp1_;
#line 455 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		if (_inner_error_ != NULL) {
#line 455 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
			if (_inner_error_->domain == G_IO_ERROR) {
#line 3911 "service.c"
				goto __catch27_g_io_error;
			}
#line 455 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 455 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
			g_clear_error (&_inner_error_);
#line 455 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
			return NULL;
#line 3920 "service.c"
		}
#line 455 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		result = _tmp2_;
#line 455 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		return result;
#line 3926 "service.c"
	}
	goto __finally27;
	__catch27_g_io_error:
	{
		GError* e = NULL;
		GError* _tmp3_;
		const gchar* _tmp4_;
#line 454 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		e = _inner_error_;
#line 454 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		_inner_error_ = NULL;
#line 457 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		_tmp3_ = e;
#line 457 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		_tmp4_ = _tmp3_->message;
#line 457 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		g_warning ("service.vala:457: %s", _tmp4_);
#line 454 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		_g_error_free0 (e);
#line 3946 "service.c"
	}
	__finally27:
#line 454 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
	if (_inner_error_ != NULL) {
#line 454 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 454 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		g_clear_error (&_inner_error_);
#line 454 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		return NULL;
#line 3957 "service.c"
	}
#line 459 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
	_tmp5_ = g_strdup ("");
#line 459 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
	result = _tmp5_;
#line 459 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
	return result;
#line 3965 "service.c"
}


/**
            avatar_path:
            @url: url to the avatar to cache

            Return value: path to the cached avatar as a string
        */
static gchar* string_replace (const gchar* self, const gchar* old, const gchar* replacement) {
	gchar* result = NULL;
	GError * _inner_error_ = NULL;
#line 1389 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1389 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
	g_return_val_if_fail (old != NULL, NULL);
#line 1389 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
	g_return_val_if_fail (replacement != NULL, NULL);
#line 3984 "service.c"
	{
		const gchar* _tmp0_;
		gchar* _tmp1_ = NULL;
		gchar* _tmp2_;
		GRegex* _tmp3_;
		GRegex* _tmp4_;
		GRegex* regex;
		GRegex* _tmp5_;
		const gchar* _tmp6_;
		gchar* _tmp7_ = NULL;
		gchar* _tmp8_;
#line 1391 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
		_tmp0_ = old;
#line 1391 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
		_tmp1_ = g_regex_escape_string (_tmp0_, -1);
#line 1391 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
		_tmp2_ = _tmp1_;
#line 1391 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
		_tmp3_ = g_regex_new (_tmp2_, 0, 0, &_inner_error_);
#line 1391 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
		_tmp4_ = _tmp3_;
#line 1391 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
		_g_free0 (_tmp2_);
#line 1391 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
		regex = _tmp4_;
#line 1391 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
		if (_inner_error_ != NULL) {
#line 1391 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
			if (_inner_error_->domain == G_REGEX_ERROR) {
#line 4014 "service.c"
				goto __catch28_g_regex_error;
			}
#line 1391 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1391 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
			g_clear_error (&_inner_error_);
#line 1391 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
			return NULL;
#line 4023 "service.c"
		}
#line 1392 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
		_tmp5_ = regex;
#line 1392 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
		_tmp6_ = replacement;
#line 1392 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
		_tmp7_ = g_regex_replace_literal (_tmp5_, self, (gssize) (-1), 0, _tmp6_, 0, &_inner_error_);
#line 1392 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
		_tmp8_ = _tmp7_;
#line 1392 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
		if (_inner_error_ != NULL) {
#line 1392 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
			_g_regex_unref0 (regex);
#line 1392 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
			if (_inner_error_->domain == G_REGEX_ERROR) {
#line 4039 "service.c"
				goto __catch28_g_regex_error;
			}
#line 1392 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
			_g_regex_unref0 (regex);
#line 1392 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1392 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
			g_clear_error (&_inner_error_);
#line 1392 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
			return NULL;
#line 4050 "service.c"
		}
#line 1392 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
		result = _tmp8_;
#line 1392 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
		_g_regex_unref0 (regex);
#line 1392 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
		return result;
#line 4058 "service.c"
	}
	goto __finally28;
	__catch28_g_regex_error:
	{
		GError* e = NULL;
#line 1390 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
		e = _inner_error_;
#line 1390 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
		_inner_error_ = NULL;
#line 1394 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
		g_assert_not_reached ();
#line 1390 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
		_g_error_free0 (e);
#line 4072 "service.c"
	}
	__finally28:
#line 1390 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
	if (_inner_error_ != NULL) {
#line 1390 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1390 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
		g_clear_error (&_inner_error_);
#line 1390 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
		return NULL;
#line 4083 "service.c"
	}
}


gchar* gwibber_service_avatar_path (GwibberService* self, const gchar* url, GError** error) {
	gchar* result = NULL;
	const gchar* _tmp0_ = NULL;
	const gchar* _tmp1_;
	gchar* _tmp2_ = NULL;
	gchar* _tmp3_;
	gchar* _tmp4_ = NULL;
	gchar* _tmp5_;
	gchar* _avatar_cache_image;
	const gchar* _tmp6_;
	GFile* _tmp7_ = NULL;
	GFile* file;
	GFile* _tmp8_;
	gboolean _tmp9_ = FALSE;
	GError * _inner_error_ = NULL;
#line 468 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 468 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
	g_return_val_if_fail (url != NULL, NULL);
#line 470 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
	_tmp0_ = g_get_user_cache_dir ();
#line 470 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
	_tmp1_ = url;
#line 470 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
	_tmp2_ = string_replace (_tmp1_, "/", "");
#line 470 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
	_tmp3_ = _tmp2_;
#line 470 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
	_tmp4_ = g_build_path (G_DIR_SEPARATOR_S, _tmp0_, "gwibber/avatars", _tmp3_, NULL);
#line 470 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
	_tmp5_ = _tmp4_;
#line 470 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
	_g_free0 (_tmp3_);
#line 470 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
	_avatar_cache_image = _tmp5_;
#line 471 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
	_tmp6_ = _avatar_cache_image;
#line 471 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
	_tmp7_ = g_file_new_for_path (_tmp6_);
#line 471 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
	file = _tmp7_;
#line 472 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
	_tmp8_ = file;
#line 472 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
	_tmp9_ = g_file_query_exists (_tmp8_, NULL);
#line 472 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
	if (_tmp9_) {
#line 473 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		result = _avatar_cache_image;
#line 473 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		_g_object_unref0 (file);
#line 473 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		return result;
#line 4141 "service.c"
	} else {
		ServiceInterface* _tmp10_;
		const gchar* _tmp11_;
		gchar* _tmp12_ = NULL;
		gchar* _tmp13_;
#line 475 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		_tmp10_ = self->priv->service;
#line 475 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		_tmp11_ = url;
#line 475 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		_tmp12_ = service_interface_GetAvatarPath (_tmp10_, _tmp11_, &_inner_error_);
#line 475 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		_tmp13_ = _tmp12_;
#line 475 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		if (_inner_error_ != NULL) {
#line 475 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
			g_propagate_error (error, _inner_error_);
#line 475 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
			_g_object_unref0 (file);
#line 475 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
			_g_free0 (_avatar_cache_image);
#line 475 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
			return NULL;
#line 4165 "service.c"
		}
#line 475 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		_g_free0 (_avatar_cache_image);
#line 475 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		_avatar_cache_image = _tmp13_;
#line 4171 "service.c"
	}
#line 476 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
	result = _avatar_cache_image;
#line 476 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
	_g_object_unref0 (file);
#line 476 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
	return result;
#line 4179 "service.c"
}


void gwibber_service_perform (GwibberService* self, const gchar* id, GError** error) {
	GError * _inner_error_ = NULL;
#line 479 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
	g_return_if_fail (self != NULL);
#line 479 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
	g_return_if_fail (id != NULL);
#line 4189 "service.c"
	{
		ServiceInterface* _tmp0_;
		const gchar* _tmp1_;
		gchar* _tmp2_;
		gchar* _tmp3_;
		gchar* _tmp4_;
		gchar* _tmp5_;
#line 482 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		_tmp0_ = self->priv->service;
#line 482 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		_tmp1_ = id;
#line 482 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		_tmp2_ = g_strconcat ("{\"id\": \"", _tmp1_, NULL);
#line 482 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		_tmp3_ = _tmp2_;
#line 482 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		_tmp4_ = g_strconcat (_tmp3_, "\"}", NULL);
#line 482 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		_tmp5_ = _tmp4_;
#line 482 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		service_interface_PerformOp (_tmp0_, _tmp5_, &_inner_error_);
#line 482 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		_g_free0 (_tmp5_);
#line 482 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		_g_free0 (_tmp3_);
#line 482 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		if (_inner_error_ != NULL) {
#line 482 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
			if (_inner_error_->domain == G_IO_ERROR) {
#line 4219 "service.c"
				goto __catch29_g_io_error;
			}
#line 482 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 482 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
			g_clear_error (&_inner_error_);
#line 482 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
			return;
#line 4228 "service.c"
		}
	}
	goto __finally29;
	__catch29_g_io_error:
	{
		GError* e = NULL;
		GError* _tmp6_;
		const gchar* _tmp7_;
#line 481 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		e = _inner_error_;
#line 481 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		_inner_error_ = NULL;
#line 484 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		_tmp6_ = e;
#line 484 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		_tmp7_ = _tmp6_->message;
#line 484 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		g_warning ("service.vala:484: %s", _tmp7_);
#line 481 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		_g_error_free0 (e);
#line 4249 "service.c"
	}
	__finally29:
#line 481 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
	if (_inner_error_ != NULL) {
#line 481 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		g_propagate_error (error, _inner_error_);
#line 481 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		return;
#line 4258 "service.c"
	}
}


void gwibber_service_follow (GwibberService* self, const gchar* account, const gchar* screen_name, gboolean follow, GError** error) {
	gchar* _tmp0_;
	gchar* action;
	gboolean _tmp1_;
	GError * _inner_error_ = NULL;
#line 489 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
	g_return_if_fail (self != NULL);
#line 489 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
	g_return_if_fail (account != NULL);
#line 489 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
	g_return_if_fail (screen_name != NULL);
#line 491 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
	_tmp0_ = g_strdup ("unfollow");
#line 491 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
	action = _tmp0_;
#line 492 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
	_tmp1_ = follow;
#line 492 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
	if (_tmp1_) {
#line 4282 "service.c"
		gchar* _tmp2_;
#line 493 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		_tmp2_ = g_strdup ("follow");
#line 493 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		_g_free0 (action);
#line 493 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		action = _tmp2_;
#line 4290 "service.c"
	}
	{
		ServiceInterface* _tmp3_;
		const gchar* _tmp4_;
		gchar* _tmp5_;
		gchar* _tmp6_;
		gchar* _tmp7_;
		gchar* _tmp8_;
		const gchar* _tmp9_;
		gchar* _tmp10_;
		gchar* _tmp11_;
		gchar* _tmp12_;
		gchar* _tmp13_;
		const gchar* _tmp14_;
		gchar* _tmp15_;
		gchar* _tmp16_;
		gchar* _tmp17_;
		gchar* _tmp18_;
#line 496 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		_tmp3_ = self->priv->service;
#line 496 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		_tmp4_ = account;
#line 496 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		_tmp5_ = g_strconcat ("{\"account\": \"", _tmp4_, NULL);
#line 496 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		_tmp6_ = _tmp5_;
#line 496 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		_tmp7_ = g_strconcat (_tmp6_, "\", \"operation\": \"", NULL);
#line 496 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		_tmp8_ = _tmp7_;
#line 496 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		_tmp9_ = action;
#line 496 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		_tmp10_ = g_strconcat (_tmp8_, _tmp9_, NULL);
#line 496 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		_tmp11_ = _tmp10_;
#line 496 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		_tmp12_ = g_strconcat (_tmp11_, "\", \"args\": {\"screen_name\": \"", NULL);
#line 496 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		_tmp13_ = _tmp12_;
#line 496 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		_tmp14_ = screen_name;
#line 496 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		_tmp15_ = g_strconcat (_tmp13_, _tmp14_, NULL);
#line 496 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		_tmp16_ = _tmp15_;
#line 496 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		_tmp17_ = g_strconcat (_tmp16_, "\"}}", NULL);
#line 496 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		_tmp18_ = _tmp17_;
#line 496 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		service_interface_PerformOp (_tmp3_, _tmp18_, &_inner_error_);
#line 496 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		_g_free0 (_tmp18_);
#line 496 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		_g_free0 (_tmp16_);
#line 496 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		_g_free0 (_tmp13_);
#line 496 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		_g_free0 (_tmp11_);
#line 496 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		_g_free0 (_tmp8_);
#line 496 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		_g_free0 (_tmp6_);
#line 496 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		if (_inner_error_ != NULL) {
#line 496 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
			if (_inner_error_->domain == G_IO_ERROR) {
#line 4359 "service.c"
				goto __catch30_g_io_error;
			}
#line 496 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
			_g_free0 (action);
#line 496 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 496 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
			g_clear_error (&_inner_error_);
#line 496 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
			return;
#line 4370 "service.c"
		}
	}
	goto __finally30;
	__catch30_g_io_error:
	{
		GError* e = NULL;
		GError* _tmp19_;
		const gchar* _tmp20_;
#line 495 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		e = _inner_error_;
#line 495 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		_inner_error_ = NULL;
#line 498 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		_tmp19_ = e;
#line 498 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		_tmp20_ = _tmp19_->message;
#line 498 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		g_warning ("service.vala:498: %s", _tmp20_);
#line 495 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		_g_error_free0 (e);
#line 4391 "service.c"
	}
	__finally30:
#line 495 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
	if (_inner_error_ != NULL) {
#line 495 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		g_propagate_error (error, _inner_error_);
#line 495 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		_g_free0 (action);
#line 495 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		return;
#line 4402 "service.c"
	}
#line 489 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
	_g_free0 (action);
#line 4406 "service.c"
}


void gwibber_service_update_indicators (GwibberService* self, const gchar* stream) {
	const gchar* _tmp0_;
	GError * _inner_error_ = NULL;
#line 502 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
	g_return_if_fail (self != NULL);
#line 504 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
	_tmp0_ = stream;
#line 504 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
	if (_tmp0_ == NULL) {
#line 505 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		stream = "home";
#line 4421 "service.c"
	}
	{
		ServiceInterface* _tmp1_;
		const gchar* _tmp2_;
#line 507 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		_tmp1_ = self->priv->service;
#line 507 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		_tmp2_ = stream;
#line 507 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		service_interface_UpdateIndicators (_tmp1_, _tmp2_, &_inner_error_);
#line 507 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		if (_inner_error_ != NULL) {
#line 507 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
			if (_inner_error_->domain == G_IO_ERROR) {
#line 4436 "service.c"
				goto __catch31_g_io_error;
			}
#line 507 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 507 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
			g_clear_error (&_inner_error_);
#line 507 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
			return;
#line 4445 "service.c"
		}
	}
	goto __finally31;
	__catch31_g_io_error:
	{
		GError* e = NULL;
		GError* _tmp3_;
		const gchar* _tmp4_;
#line 506 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		e = _inner_error_;
#line 506 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		_inner_error_ = NULL;
#line 509 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		_tmp3_ = e;
#line 509 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		_tmp4_ = _tmp3_->message;
#line 509 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		g_warning ("service.vala:509: %s", _tmp4_);
#line 506 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		_g_error_free0 (e);
#line 4466 "service.c"
	}
	__finally31:
#line 506 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
	if (_inner_error_ != NULL) {
#line 506 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 506 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		g_clear_error (&_inner_error_);
#line 506 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		return;
#line 4477 "service.c"
	}
}


GwibberService* gwibber_service_construct (GType object_type) {
	GwibberService * self = NULL;
#line 45 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
	self = (GwibberService*) g_object_new (object_type, NULL);
#line 45 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
	return self;
#line 4488 "service.c"
}


GwibberService* gwibber_service_new (void) {
#line 45 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
	return gwibber_service_construct (GWIBBER_TYPE_SERVICE);
#line 4495 "service.c"
}


static void g_cclosure_user_marshal_VOID__STRING_STRING_STRING (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data) {
	typedef void (*GMarshalFunc_VOID__STRING_STRING_STRING) (gpointer data1, const char* arg_1, const char* arg_2, const char* arg_3, gpointer data2);
	register GMarshalFunc_VOID__STRING_STRING_STRING callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 45 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
	g_return_if_fail (n_param_values == 4);
#line 45 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 45 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		data1 = closure->data;
#line 45 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		data2 = param_values->data[0].v_pointer;
#line 4514 "service.c"
	} else {
#line 45 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		data1 = param_values->data[0].v_pointer;
#line 45 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		data2 = closure->data;
#line 4520 "service.c"
	}
#line 45 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
	callback = (GMarshalFunc_VOID__STRING_STRING_STRING) (marshal_data ? marshal_data : cc->callback);
#line 45 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
	callback (data1, g_value_get_string (param_values + 1), g_value_get_string (param_values + 2), g_value_get_string (param_values + 3), data2);
#line 4526 "service.c"
}


static void _gwibber_service_service_available_gwibber_utils_available (GwibberUtils* _sender, gboolean up, gpointer self) {
#line 101 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
	gwibber_service_service_available (self, up);
#line 4533 "service.c"
}


static void _gwibber_service_on_loading_started_service_interface_loading_started (ServiceInterface* _sender, gpointer self) {
#line 102 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
	gwibber_service_on_loading_started (self);
#line 4540 "service.c"
}


static void _gwibber_service_on_loading_complete_service_interface_loading_complete (ServiceInterface* _sender, gpointer self) {
#line 103 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
	gwibber_service_on_loading_complete (self);
#line 4547 "service.c"
}


static void _gwibber_service____lambda6_ (GwibberService* self, const gchar* source) {
	const gchar* _tmp0_;
#line 104 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
	g_return_if_fail (source != NULL);
#line 105 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
	_tmp0_ = source;
#line 105 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
	gwibber_service_on_error (self, _tmp0_);
#line 4559 "service.c"
}


static void __gwibber_service____lambda6__service_interface_error (ServiceInterface* _sender, const gchar* error_str, gpointer self) {
#line 104 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
	_gwibber_service____lambda6_ (self, error_str);
#line 4566 "service.c"
}


static GObject * gwibber_service_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties) {
	GObject * obj;
	GObjectClass * parent_class;
	GwibberService * self;
	GwibberMessages* _tmp12_;
	GError * _inner_error_ = NULL;
#line 90 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
	parent_class = G_OBJECT_CLASS (gwibber_service_parent_class);
#line 90 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 90 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
	self = GWIBBER_SERVICE (obj);
#line 4582 "service.c"
	{
		ServiceInterface* _tmp0_ = NULL;
		ServiceInterface* _tmp1_;
		GwibberUtils* _tmp2_;
		GwibberUtils* _tmp3_;
		GwibberUtils* _tmp4_;
		ServiceInterface* _tmp5_;
		ServiceInterface* _tmp6_;
		ServiceInterface* _tmp7_;
#line 94 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		_tmp0_ = g_initable_new (TYPE_SERVICE_INTERFACE_PROXY, NULL, &_inner_error_, "g-flags", 0, "g-name", GWIBBER_SERVICE_service_name, "g-bus-type", G_BUS_TYPE_SESSION, "g-object-path", GWIBBER_SERVICE_service_path, "g-interface-name", "com.Gwibber.Service", NULL);
#line 94 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		_tmp1_ = (ServiceInterface*) _tmp0_;
#line 94 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		if (_inner_error_ != NULL) {
#line 94 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
			if (_inner_error_->domain == G_IO_ERROR) {
#line 4600 "service.c"
				goto __catch32_g_io_error;
			}
#line 94 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 94 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
			g_clear_error (&_inner_error_);
#line 4607 "service.c"
		}
#line 94 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		_g_object_unref0 (self->priv->service);
#line 94 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		self->priv->service = _tmp1_;
#line 99 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		_tmp2_ = gwibber_utils_new ();
#line 99 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		_g_object_unref0 (self->priv->utils);
#line 99 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		self->priv->utils = _tmp2_;
#line 100 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		_tmp3_ = self->priv->utils;
#line 100 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		gwibber_utils_setup (_tmp3_, GWIBBER_SERVICE_service_name, &_inner_error_);
#line 100 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		if (_inner_error_ != NULL) {
#line 100 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
			if (_inner_error_->domain == G_IO_ERROR) {
#line 4627 "service.c"
				goto __catch32_g_io_error;
			}
#line 100 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 100 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
			g_clear_error (&_inner_error_);
#line 4634 "service.c"
		}
#line 101 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		_tmp4_ = self->priv->utils;
#line 101 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		g_signal_connect_object (_tmp4_, "available", (GCallback) _gwibber_service_service_available_gwibber_utils_available, self, 0);
#line 102 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		_tmp5_ = self->priv->service;
#line 102 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		g_signal_connect_object (_tmp5_, "loading-started", (GCallback) _gwibber_service_on_loading_started_service_interface_loading_started, self, 0);
#line 103 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		_tmp6_ = self->priv->service;
#line 103 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		g_signal_connect_object (_tmp6_, "loading-complete", (GCallback) _gwibber_service_on_loading_complete_service_interface_loading_complete, self, 0);
#line 104 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		_tmp7_ = self->priv->service;
#line 104 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		g_signal_connect_object (_tmp7_, "error", (GCallback) __gwibber_service____lambda6__service_interface_error, self, 0);
#line 4652 "service.c"
	}
	goto __finally32;
	__catch32_g_io_error:
	{
		GError* e = NULL;
		GError* _tmp8_;
		const gchar* _tmp9_;
		gchar* _tmp10_;
		gchar* _tmp11_;
#line 92 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		e = _inner_error_;
#line 92 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		_inner_error_ = NULL;
#line 111 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		_tmp8_ = e;
#line 111 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		_tmp9_ = _tmp8_->message;
#line 111 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		_tmp10_ = g_strconcat ("Unable to get Gwibber service: ", _tmp9_, NULL);
#line 111 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		_tmp11_ = _tmp10_;
#line 111 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		g_warning ("service.vala:111: %s", _tmp11_);
#line 111 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		_g_free0 (_tmp11_);
#line 92 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		_g_error_free0 (e);
#line 4680 "service.c"
	}
	__finally32:
#line 92 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
	if (_inner_error_ != NULL) {
#line 92 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 92 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
		g_clear_error (&_inner_error_);
#line 4689 "service.c"
	}
#line 114 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
	_tmp12_ = gwibber_messages_new ();
#line 114 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
	_g_object_unref0 (self->priv->messages);
#line 114 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
	self->priv->messages = _tmp12_;
#line 90 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
	return obj;
#line 4699 "service.c"
}


static void gwibber_service_class_init (GwibberServiceClass * klass) {
#line 45 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
	gwibber_service_parent_class = g_type_class_peek_parent (klass);
#line 45 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
	g_type_class_add_private (klass, sizeof (GwibberServicePrivate));
#line 45 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
	G_OBJECT_CLASS (klass)->constructor = gwibber_service_constructor;
#line 45 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
	G_OBJECT_CLASS (klass)->finalize = gwibber_service_finalize;
#line 4712 "service.c"
	/** 
	            Service::is_available:
	            @arg0: The current state
	
	            Emitted when com.Gwibber.Service availability state changes
	        */
#line 45 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
	g_signal_new ("is_available", GWIBBER_TYPE_SERVICE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__BOOLEAN, G_TYPE_NONE, 1, G_TYPE_BOOLEAN);
#line 4721 "service.c"
	/**
	            Service::loading_started:
	
	            Emitted when an operations starts
	        */
#line 45 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
	g_signal_new ("loading_started", GWIBBER_TYPE_SERVICE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 4729 "service.c"
	/**
	            Service::loading_started:
	
	            Emitted when an operations is complete
	        */
#line 45 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
	g_signal_new ("loading_complete", GWIBBER_TYPE_SERVICE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 4737 "service.c"
	/**
	            Service::error:
	            @arg0: String containing the account id
	            @arg1: String containing the error type
	            @arg2: String containing the error message
	
	            Emitted when an error is received from the service
	        */
#line 45 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
	g_signal_new ("error", GWIBBER_TYPE_SERVICE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__STRING_STRING_STRING, G_TYPE_NONE, 3, G_TYPE_STRING, G_TYPE_STRING, G_TYPE_STRING);
#line 4748 "service.c"
}


static void gwibber_service_instance_init (GwibberService * self) {
#line 45 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
	self->priv = GWIBBER_SERVICE_GET_PRIVATE (self);
#line 4755 "service.c"
}


static void gwibber_service_finalize (GObject* obj) {
	GwibberService * self;
#line 45 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
	self = GWIBBER_SERVICE (obj);
#line 50 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
	_g_object_unref0 (self->priv->service);
#line 51 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
	_g_hash_table_unref0 (self->priv->services_table);
#line 52 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
	_g_hash_table_unref0 (self->priv->service_table);
#line 53 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
	_g_hash_table_unref0 (self->priv->features_table);
#line 54 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
	_g_hash_table_unref0 (self->priv->feature_table);
#line 55 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
	_g_object_unref0 (self->priv->utils);
#line 56 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
	_g_object_unref0 (self->priv->messages);
#line 45 "/storage/1/src/gwibber/trunk/libgwibber/service.vala"
	G_OBJECT_CLASS (gwibber_service_parent_class)->finalize (obj);
#line 4779 "service.c"
}


GType gwibber_service_get_type (void) {
	static volatile gsize gwibber_service_type_id__volatile = 0;
	if (g_once_init_enter (&gwibber_service_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (GwibberServiceClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) gwibber_service_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GwibberService), 0, (GInstanceInitFunc) gwibber_service_instance_init, NULL };
		GType gwibber_service_type_id;
		gwibber_service_type_id = g_type_register_static (G_TYPE_OBJECT, "GwibberService", &g_define_type_info, 0);
		g_once_init_leave (&gwibber_service_type_id__volatile, gwibber_service_type_id);
	}
	return gwibber_service_type_id__volatile;
}



